<p>Window-Werte oder Wondo-Funktionen 
<p>Zur Maria-DB gibt es folgende Seiten (auf Englisch):<br>
Übersicht: <a href='https://mariadb.com/kb/en/window-functions-overview/' target='MariaDB'>https://mariadb.com/kb/en/window-functions-overview/</a><br>
Funktionen: <a href='https://mariadb.com/kb/en/window-functions/' target='MariaDB'>https://mariadb.com/kb/en/window-functions/</a><br>
Frames: <a href='https://mariadb.com/kb/en/window-frames/' target='MariaDB'>https://mariadb.com/kb/en/window-frames/</a></p>
<h4>Implementierung im WS-Reporter</h4>
<p>Im WS-Reporter wird der Select-Ausdruck ermittelt, nachdem alle Daten zusammengeführt wurden. 
Dieser Wert wird für die jeweilige Zeilen-Gruppe ermittelt, die bei der Report-Erstellung als "wirksam ab Spalte" angegeben wurde.</p>
<p>Technisch wird die Funktion in SQL wie folgt umgesetzt:<pre>
    <i>funktion</i>(<i>Ausdruck</i>) OVER (
       PARTITION BY [Zeilen bis zur gewählten Ebene]
       ORDER BY [gewählter Wert]
       )
</pre>
Das Ergebnis wird immer als Dezimalzahl behandelt.</p>
<p>In der Spezifikation der Datenquelle wird nur die Funktion mit dem Klammer-Ausdruck, als Select-Ausdruck
angegeben. Der OVER-Ausdruck wird nach den Spezifikationen im Report-Ausdruck dynamisch erzeugt. Beispiele für Select-Ausdrücke:
<ul>
<li> SUM(wert): Addiert die Werte in der Gruppe kumuliert, wenn eine Reihenfolge angegeben wird.</li>
</ul> 
<h4>Beschreibung</h4>
<p>Damit solche Filter bei der Report-Definition sinnvoll verwendet werden können, müssen sie in der Datenquelle
ausführlich beschrieben werden. Neben dem Zweck des Filters, z.B. "Auswahl nach Rangfolge", muss beschrieben werden,
was im Feld Vergleich einzugeben ist.   
 
<p>Beispiele finden Sie unter "Report-Definitionen".</p>
