<p>In dieser Anleitung gehen wir davon aus, dass der WS-Reporter auf einem
Apache-Web-Server mit einer Maria- oder Mysql-Datenbank installiert werden soll. Als Installations-Verzeichnis 
wird /WS-Reporter im Wurzel-Verzeichnis des Web-Servers angenommen. Dann passen auch die .htaccess-Dateien
für die Absicherung. Andere Konfigurationen werden ebenfalls unterstützt, erfordern aber weitere Anpassungen.</p>
<p>Im Verzeichnis WS-Reporter sorgt die .htaccess-Datei für die Umleitung ungültiger Abruf-Versuche
auf block.php zum Blockieren der IP-Adressen. In der Unterverzeichnissen includes und phpsec sorgen 
blockieren die .htaccess-Dateien Abrufe über den Web-Server.</p>
<h4>Vorbereiten der Datenbank</h4>
<p>Bei Maria-DB und Mysql werden die Schemas als Datenbank bezeichnet. Alle Datenbanken auf einem Server sind
mit einer Anmeldung zugänglich, wenn der angemeldete Benutzer die erforderlichen Rechte hat.  
Bei der Spezifikation der Datenquelle muss dann der voll qualifizierte Namen in der Form <code>Datenbank.TabelleBzwView</code>
angegeben werden. Dabei müsste aber die Datenquelle umfassend überarbeitet werden, wenn z.B. von den Testdaten
auf produktive Daten umgestellt wird. Deshalb verwendet der WS-Reporter für den Zugriff auf die auszuwertenden
Daten eine separate Anmeldung. Dabei können mehrere Datenbanken mit verschiedenen Alias-Namen definiert werden.
Die gewünschte Datenbank wird dann über den Alias in der Spezifikation der Datenquelle ausgewählt. So kann auch
derselbe Alias in verschiedenen Instanzen des WS-Reporters auf verschiedene Datenbanken (Test und Produktion) verweisen.</p>  
<h5>Auswahl von Zeichensatz und Collation</h5>
<p>Intern arbeitet der WS-Reporter bei Namen case-sensitiv. D.h. name und Name werden als verschiedene Einträge betrachtet,
wenn sie z.B. in Berechnungen verwendet werden. Die Test-Prozeduren funktionieren dann nur 100%ig, wenn auch die Datenbank
mit einer case-sensitiven COLLATION, z.B. utf8_bin angelegt wird. Allerdings sind dann auch Filter für die Auswahllisten
case-sensitiv. Wird die Datebank case-insensitiv angelegt, z.B. mit der COLLATION utf8_german2_ci, funktionieren diese Filter
case-insensitiv. Beim Testen kann es dann aber dazu kommen, dass Fehler in der Groß-Kleinschreibung nicht erkannt werden.</p>
<p>Bei einer nachträglichen Änderung der COLLATION kann es zumindest bei der aktuellen MariaDB zu Fehlern kommen, die
die Datenbank unbrauchbar machen. In diesen Fällen, müssen die Daten der Tabellen exportiert und neu importiert werden.   
</p>
<h5>Benutzer und Benutzer-Rechte</h5>
<p>Für die Installation wird ein Datenbank-Benutzer mit allen Rechten zum Erstellen der WS-Tabellen benötigt.</p> 
<p>Im Betrieb benötigt der verwendete Benutzer für die WS-Reporter-Datenbank neben den Rechten SELECT, INSERT, 
UPDATE und DELETE auch das Recht CREATE TEMPORARY TABLES. Für die Daten wird nur die Rechte SELECT und CREATE TEMPORARY TABLES benötigt.</p>   
<h4>Tar-File entpacken</h4>
<p>Der Befehl <code>tar -xf WS-Reporter...tar</code> entpackt die Anwendung in ein neu erstelltes Verzeichnis WS-Reporter.
Dieses Verzeichnis muss mit allen Unterverzeichnissen in das Wurzel-Verzeichnis des Web-Servers kopiert
(oder verlinkt) werden. Der Web-Server benötigt Lese-Rechte.</p> 

<h4>Installations-Aufruf</h4>
<p>Rufen Sie über den Browser das Installationsprogramm <code>WS-Reporter/installation.php</code> auf.</p>
<p>Melden Sie sich an der Datenbank an. Dazu müssen Sie den Host, den Namen der Datenbank (des Schemas),
Benutzer-ID und Passwort des technischen Admin-Users angeben. Beispiel:</p>
<img src='anleitung/installation1.png'>
<h4>Erstellen der WS-Reporter-Tabellen</h4>
<p>Nach der erfolgreichen Anmeldung können Sie die Tabellen des WS-Reporters in der Datenbank erstellen.
Klicken Sie dazu auf die entsprechende Schaltfläche. Sie erhalten dann nach kurzer Zeit
die Meldungen zu den erstellten Tabellen und dem View reportVerzeichnis.</p> 
<h4>Datenbank-Zugriff einrichten</h4>
<p>Im nächsten Schritt wird der Zugriff des WS-Reporters auf die Datenbank erzeugt. Dabei tragen Sie
den technischen User und sein Passwort für die Datenbank-Verbindung zum WS-Reporter und seinen Tabellen ein.
Wenn die Daten für die Reports in einer anderen Datenbank liegen, könen Sie diesen Zugriff und die Daten 
des technischen Users hier ebenfalls eintragen. Bei der Spezifikation der Datenquellen können Sie dann zwischen
den Daten der anderen Datenbank (DWH) und den Daten des WS-Reporters (Standard) wählen. Für Mysql und MariaDB 
wird eine eigenes DWH-Schema ausdrücklich empfohlen. Der Standard-Zugriff wird für das Report-Verzeichnis und
ggf. weitere Analysen der Spezifikationen im WS-Reporter benötigt.</p>
<img src='anleitung/installation2.png'>
<p>Aus den
eingetragenen Informationen wird mit &quot;Zugriff einrichten&quot; eine Datei createDBH.inc erzeugt, die in das Verzeichnis
<code>WS-Reporter/phpsec</code> kopiert werden muss. Hinweis: Achten Sie auf das Lese-Recht für den Web-Server.</p> 
<h4>Administrator einrichten</h4>
<p>Nach dem Speichern der Datei createDBH.inc können Sie den Adiministrator-Zugang anlegen:</p>
<img src='anleitung/installation3.png'>
<p>User-ID und Passwort werden für die Anmeldung benötigt. Der Benutzer-Name wird zur Anzeige verwendet.</p>
<p>Nach dem Klick auf "Administrator anlegen" sollten sollten Sie die Meldung bekommen, dass
die Installation abgeschlossen ist, und Sie sich mit dem gerade angelegten administrativen
User anmelden sollen. Der Link "zur Anmeldung" führt Sie dann zur Anmeldemaske.</p> 

 