<?php
/**
 * Projekt: WS-Reporter
 *          Benutzerverwaltung und Rechte-Vergabe
 *
 * Autor:    Wilfried Schollenberger
 *           WS Unternehmensberatung und Controlling-Systeme GmbH
 * Kontakt:  wisch@ws-unternehmensberatung.de
 * Lizenz:   GPL 3.0
 *
 * Stand:    12.8.2022 NLS
 *
 */
$editUser="X";
include 'includes/defender.inc';
require_once './includes/funktionen.inc';
require_once './phpsec/createDBH.inc';
if (session_status() == PHP_SESSION_NONE)  session_start();

anmeldungPruefen();
adminRechteVerlangen();

if (array_key_exists('action', $_REQUEST)){
    if ($_REQUEST['action'] == 'editUser'){
        $stmt = $dbh->prepare('select * from wsrUser where user = :user');
        $stmt->execute(array('user'=>$_REQUEST['userID']));
        if ($stmt->fetch()){
            $stmt->closeCursor();
            $stmt = $dbh->prepare('update wsrUser set password=:pass, userLongName = :longName, '
                .'uLanguage = :language, wsrUebersetzer = :uebersetzer, '
                .'adminRecht = :admin, endUser = :endUser, error_count = 0 where user = :user');
        }else{
            $stmt->closeCursor();
            $stmt = $dbh->prepare('insert into wsrUser set password=:pass, userLongName = :longName, '
                .' uLanguage = :language, wsrUebersetzer = :uebersetzer, '
                .' adminRecht = :admin,  endUser = :endUser, error_count = 0, user = :user');
            
        }
//        var_dump($_REQUEST);
//        var_dump(isset($_REQUEST['admin']));
        if ($stmt === false) var_dump($dbh->errorInfo());
        else{
            if (array_key_exists('admin', $_REQUEST)) $admin = 1;
            else $admin = 0;
            if (array_key_exists('endUser', $_REQUEST)) $endUser = 1;
            else $endUser = 0;
            if (array_key_exists('uebersetzer', $_REQUEST)) $uebersetzer = 1;
            else $uebersetzer = 0;
            $erg = $stmt->execute(array(
                'user'=>$_REQUEST['userID'],
                'longName'=>$_REQUEST['userName'],
                'pass'=>$_REQUEST['pass'],
                'language'=>$_REQUEST['language'],
                'admin'=> $admin,
                'uebersetzer'=> $uebersetzer,
                'endUser'=> $endUser
            ));
        if ($erg === false)var_dump($stmt->errorInfo());
        }
    }
    if ($_REQUEST['action'] == 'setLesen' && array_key_exists('user', $_REQUEST)){
        $stmt = $dbh->prepare('select * from wsrRechte where user = :user and table_name = :table');
        $stmt->execute(array('user'=>$_REQUEST['userID'] , 'table' => $_REQUEST['datenquelle']));
        if ($stmt->fetch()){
            $stmt->closeCursor();
            
        }else{
            $stmt->closeCursor();
            $stmt = $dbh->prepare('insert into wsrRechte set table_name=:table, user = :user, adminRecht = 0');
            $stmt->execute(array('user'=>$_REQUEST['userID'] , 'table' => $_REQUEST['datenquelle']));            
        }        
    }
    if ($_REQUEST['action'] == 'unsetLesen' && array_key_exists('user', $_REQUEST)){
        $stmt = $dbh->prepare('select * from wsrRechte where user = :user and table_name = :table');
        $stmt->execute(array('user'=>$_REQUEST['userID'] , 'table' => $_REQUEST['datenquelle']));
        if ($stmt->fetch()){
            $stmt->closeCursor();
            $stmt = $dbh->prepare('delete from wsrRechte where table_name=:table and user = :user');
            $stmt->execute(array('user'=>$_REQUEST['userID'] , 'table' => $_REQUEST['datenquelle']));
        }  
    }
    if ($_REQUEST['action'] == 'setAdmin' && array_key_exists('user', $_REQUEST)){
        $stmt = $dbh->prepare('select * from wsrRechte where user = :user and table_name = :table');
        $stmt->execute(array('user'=>$_REQUEST['userID'] , 'table' => $_REQUEST['datenquelle']));
        if ($stmt->fetch()){
            $stmt->closeCursor();
            $stmt = $dbh->prepare('update wsrRechte set adminRecht = 1 where table_name=:table and user = :user');
            $stmt->execute(array('user'=>$_REQUEST['userID'] , 'table' => $_REQUEST['datenquelle']));
        }else{
            $stmt->closeCursor();
            $stmt = $dbh->prepare('insert into wsrRechte set table_name=:table, user = :user, adminRecht = 1');
            $stmt->execute(array('user'=>$_REQUEST['userID'] , 'table' => $_REQUEST['datenquelle']));
            
        }
    }
    if ($_REQUEST['action'] == 'setStartSeite' && array_key_exists('user', $_REQUEST)){       
        $stmt = $dbh->prepare('update wsrUser set reportTitle = :reportTitle where user = :user');
        $stmt->execute(array('user'=>$_REQUEST['userID'] , 'reportTitle' => $_REQUEST['startSeite']));
    }
    
    if ($_REQUEST['action'] == 'unsetAdmin' && array_key_exists('user', $_REQUEST)){
        $stmt = $dbh->prepare('select * from wsrRechte where user = :user and table_name = :table');
        $stmt->execute(array('user'=>$_REQUEST['userID'] , 'table' => $_REQUEST['datenquelle']));
        if ($stmt->fetch()){
            $stmt->closeCursor();
            $stmt = $dbh->prepare('update wsrRechte set adminRecht = 0 where table_name=:table and user = :user');
            $stmt->execute(array('user'=>$_REQUEST['userID'] , 'table' => $_REQUEST['datenquelle']));
        }
    }    
    if ($_REQUEST['action'] == 'setFilter' && array_key_exists('filter', $_REQUEST)){
        $stmt = $dbh->prepare('select * from wsrRechte where user = :user and table_name = :table');
        $stmt->execute(array('user'=>$_REQUEST['userID'] , 'table' => $_REQUEST['datenquelle']));
        if ($stmt->fetch()){
            $stmt->closeCursor();
            $stmt = $dbh->prepare('update wsrRechte set qAddFilter = :filter where table_name=:table and user = :user');
            $stmt->execute(array('user'=>$_REQUEST['userID'] , 'table' => $_REQUEST['datenquelle'],  'filter' => $_REQUEST['filter']));
        }
    }
}

?>
<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<title>WSReporter: Benutzerverwaltung</title>
<meta name="GENERATOR" content="WS-PHP: editUser.php">
<link rel="stylesheet" href="./jscss/standard2.css">
<link rel="stylesheet" href="./jscss/editUser.css">
<script type="text/javascript" src="./jscss/editUser.js">
	</script>

</head>
<?php 
if (array_key_exists('action', $_REQUEST) && 
    ($_REQUEST['action'] == "zuordnen"
/* wird vermutlich nicht mehr verwendet 
        || $_REQUEST['action'] == "setLesen"
        || $_REQUEST['action'] == "unsetLesen"
        || $_REQUEST['action'] == "setAdmin"
        || $_REQUEST['action'] == "unsetAdmin"
        || $_REQUEST['action'] == "setFilter"
        || $_REQUEST['action'] == "setFilterSql"
        || $_REQUEST['action'] == "setStartSeite"
        */
        )){
            $stmt = $dbh->prepare('select * from wsrUser where user = :user');                
            if ($stmt === false){
                var_dump($dbh->errorInfo());
                die();
            }
            if (false === $stmt->execute(array('user'=>$_REQUEST['userID']))){
                var_dump($stmt->errorInfo());
                die();
            }
            $startSeite = '';
            if ($zU=$stmt->fetchObject()){
                if ($zU->reportTitle != null ) $startSeite = $zU->reportTitle;
                
            }
            $stmt->closeCursor();
}
    ?>

<body>
<h1>WS-Reporter: Benutzerverwaltung</h1>
<div class="inlineBox">
<h3>Benutzer anlegen</h3>
<form action="./editUser.php" method="post" id="form" id="userID">
<input type="hidden" name="action" value="editUser" />
<input type="hidden" name="datenquelle" value="" />
<input type="hidden" name="filter" value="" />
<input type="hidden" name="startSeite" value="" />
<table>
<?php if (isset($zU)){?>
<tr><td>Benutzer: </td><td><input type="text" name="userID" value="<?=$zU->user?>" /></td></tr>
<tr><td>Benutzer-Name (lang):</td><td><input type="text" name="userName" value="<?=$zU->userLongName?>" /></td></tr>
<tr><td>Passwort:</td><td><input type="text" name="pass" value="<?=$zU->password?>"  /></td></tr>
<tr><td>Sprache:</td><td><select name='language'>
<option value='de' <?php if($zU->uLanguage != null && $zU->uLanguage == 'de') echo 'selected';?>>Deutsch</option>
<option value='en' <?php if($zU->uLanguage != null && $zU->uLanguage == 'en') echo 'selected';?>>Englisch</option>
<option value='fr' <?php if($zU->uLanguage != null && $zU->uLanguage == 'fr') echo 'selected';?>>Französisch</option>
</select></td></tr>
<tr><td>Admin-Rechte:</td><td> <input type="checkbox" name="admin" 
   <?php if($zU->adminRecht != null && $zU->adminRecht > 0) echo 'checked';?> ></td></tr>
<tr><td>Übersetzer:</td><td> <input type="checkbox" name="uebersetzer" 
<?php if($zU->wsrUebersetzer != null && $zU->wsrUebersetzer > 0) echo 'checked';?> ></td></tr>
<tr><td>End-User:</td><td> <input type="checkbox" name="endUser" 
	<?php if($zU->endUser != null && $zU->endUser > 0) echo 'checked';?> ></td></tr>
 <?php }else{?>
<tr><td>Benutzer: </td><td><input type="text" name="userID" /></td></tr>
<tr><td>Benutzer-Name (lang):</td><td><input type="text" name="userName" /></td></tr>
<tr><td>Passwort:</td><td><input type="text" name="pass" /></td></tr>
<tr><td>Sprache:</td><td><select name='language'>
<option value='de' selected >Deutsch</option>
<option value='en' >Englisch</option>
<option value='fr' >Französisch</option>
</select></td></tr>
<tr><td>Admin-Rechte:</td><td> <input type="checkbox" name="admin"></td></tr>
<tr><td>Übersetzer:</td><td> <input type="checkbox" name="uebersetzer"  ></td></tr>
<tr><td>End-User:</td><td> <input type="checkbox" name="endUser"></td></tr>
 <?php } ?>
</table>
<input type="submit" value="Benutzer anlegen oder Passwort neu setzen">
</form>
</div>
<div class="inlineBox">
<h3>Benutzer</h3>
<table>
<thead>
<tr><th>Benutzer-ID</th><th>Name</th><th>Admin.</th><th>zuordnen</th><th>Anmelde-<br>Fehler</th></tr>
</thead>
<tbody>
<?php 
if ($stmt = $dbh->query('select * from wsrUser order by user')){
    while ($z = $stmt->fetchObject()){
?>
<tr><th class="left"><?=$z->user ?></th><td><?=$z->userLongName ?></td>
<td class=center><?php if ($z->adminRecht) echo 'X'; else echo '&nbsp';?></td>
<td><button onclick="zuordnen('<?=$z->user ?>')">zuordnen</button></td>
<td><?=$z->error_count ?></td> </tr>       
<?php 
    }
  $stmt->closeCursor();  
}else{
    echo "Fehler bei Benutzer-Abfrage<pre>\n";
    var_dump($dbh->errorInfo());
    echo('</pre>');
}
?>
</tbody>
</table>
</div>
<?php 
if (array_key_exists('action', $_REQUEST) 
    && $_REQUEST['action'] == "zuordnen"){
?>


<div class="inlineBox">
<h3 class="help"  title="Hier werden die Rolle für die Report-Auswahl
und global anzuwendende Filter eingegeben.
Alternativ zu einer Rolle kann die Startseite auch direkt
eingegeben werden." 

>Benutzer "<?=$_REQUEST['userID'] ?>"</h3>    
<p>Report für Startseite:
<input name="startSeite" type="text" value="<?=quoteForHTML($startSeite)?>" onchange="setStartSeite('<?=$_REQUEST['userID'] ?>',this.value)" 
size="60" /> 
</p>
<p>Rolle: <select onchange="setRolle('<?=$_REQUEST['userID'] ?>',this.value)">
<option value='' >--</option>
<?php 
 $stmt = $dbh->query('select rolle from wsrRollen order by rolle');
 while ($zr = $stmt->fetchObject()){
?>
<option value='<?= $zr->rolle ?>' <?=checkSel($zr->rolle, $zU->rolle) ?>><?= $zr->rolle ?></option>
<?php 
 }
?>
</select> 
<table>    
<thead>
<tr><th>Filter (global)</th><th>Filter-Werte</th><th>&nbsp</th></tr>
</thead>
<tbody>
<tr><td><input type="text" value="<?=$zU->qAddFilter?>" onchange="setUserFilter('<?=$_REQUEST['userID'] ?>','AddFilter',this.value)" 
id='userFilter1' /></td>
<td>Wert / von: <input type="text" value="<?=quoteForText($zU->qAddFilterVon)?>" 
      onchange="setUserFilter('<?=$_REQUEST['userID'] ?>','AddFilterVon',this.value)" />
 bis: <input type="text" value="<?=quoteForText($zU->qAddFilterBis)?>" 
      onchange="setUserFilter('<?=$_REQUEST['userID'] ?>','AddFilterBis',this.value)" /></td>
<td class="editUserFilter" onclick="showFilter(<?="'".$_REQUEST['userID']."',''" ?>,'userFilter1')">&nbsp;?&nbsp;</td>
</tr>
<tr>
<td><input type="text" value="<?=$zU->qAddFilter2?>" onchange="setUserFilter('<?=$_REQUEST['userID'] ?>','AddFilter2',this.value)" 
    id='userFilter2'     /></td>
<td>Wert / von: <input type="text" value="<?=quoteForText($zU->qAddFilter2Von)?>" 
      onchange="setUserFilter('<?=$_REQUEST['userID'] ?>','AddFilter2Von',this.value)" />
 bis: <input type="text" value="<?=quoteForText($zU->qAddFilter2Bis)?>" 
      onchange="setUserFilter('<?=$_REQUEST['userID'] ?>','AddFilter2Bis',this.value)" /></td>
<td class="editUserFilter" onclick="showFilter(<?="'".$_REQUEST['userID']."',''" ?>,'userFilter2')">&nbsp;?&nbsp;</td>
</tr>

</tbody>
</table>
</div>

<div class="inlineBox">
<h3 class="help"  title="Wenn dem Benutzer eine Datenquelle zugeordnet wird,
kann er alle Reports, die darauf primär aufbauen,
ausführen und temporär eigene Reports erstellen.
Wenn der Benutzer zusätzlich das Admin-Recht bekommt,
kann er auch Reports speichern, sowie alle bereits erstellten
Report-Definitionen ändern und löschen." 

>Zuordnung des Benutzers "<?=$_REQUEST['userID'] ?>" zu Datenquellen</h3>    
<table>    
<thead>
<tr><th>Datenquelle</th><th>lesen</th><th>Admin.</th><th>Filter</th><th>Filter-Werte</th><th>&nbsp;</th></tr>
</thead>
<tbody>
<?php 
 $stmt = $dbh->prepare('select q.table_name, q.attribute as title, r.user, r.adminRecht, '
     .' r.qAddFilter, r.qAddFilterVon, r.qAddFilterBis, r.qAddFilter2, r.qAddFilter2Von, r.qAddFilter2Bis'
     .' from queryAttribute q left join wsrRechte r on r.user = :user and r.table_name = q.table_name'
     .' where q.SatzTyp = 2 order by title');
 if ($stmt === false){
     var_dump($dbh->errorInfo());
     die();
 }
 if (false === $stmt->execute(array('user'=>$_REQUEST['userID']))){
     var_dump($stmt->errorInfo());
     die();
 }
 while ($z=$stmt->fetchObject()){
     ?>
<tr><th class="left" rowspan="2" title=<?=$z->table_name ?>><?=$z->title?></th>
<td class="center" rowspan="2"><input type="checkbox" <?php if($z->user !== null) echo 'checked';?> onclick="setLesen('<?=$z->table_name ?>','<?=$_REQUEST['userID'] ?>',this.checked)" /></td>
<td class="center" rowspan="2"><input type="checkbox" <?php if($z->adminRecht != null && $z->adminRecht > 0) echo 'checked';?> onclick="setAdmin('<?=$z->table_name ?>','<?=$_REQUEST['userID'] ?>',this.checked)" /></td>
<td><input type="text" value="<?=$z->qAddFilter?>" 
		onchange="setFilter('<?=$z->table_name ?>','<?=$_REQUEST['userID'] ?>','AddFilter',this.value)" 
      id = "<?=$z->table_name ?>UserFilter1" 
		/></td>
<td>Wert / von: <input type="text" value="<?=quoteForText($z->qAddFilterVon)?>" 
      onchange="setFilter('<?=$z->table_name ?>','<?=$_REQUEST['userID'] ?>','AddFilterVon',this.value)" />
 bis: <input type="text" value="<?=quoteForText($z->qAddFilterBis)?>" 
      onchange="setFilter('<?=$z->table_name ?>','<?=$_REQUEST['userID'] ?>','AddFilterBis',this.value)" /></td>
<td class="editUserFilter" onclick="showFilter('<?=$_REQUEST['userID']?>','<?=$z->table_name ?>','<?=$z->table_name ?>UserFilter1')">&nbsp;?&nbsp;</td>

</tr>
<tr>
<td><input type="text" value="<?=$z->qAddFilter2?>" 
      onchange="setFilter('<?=$z->table_name ?>','<?=$_REQUEST['userID'] ?>','AddFilter2',this.value)"
      id = "<?=$z->table_name ?>UserFilter2" 
      /></td>
<td>Wert / von: <input type="text" value="<?=quoteForText($z->qAddFilter2Von)?>" 
      onchange="setFilter('<?=$z->table_name ?>','<?=$_REQUEST['userID'] ?>','AddFilter2Von',this.value)" />
 bis: <input type="text" value="<?=quoteForText($z->qAddFilter2Bis)?>" 
      onchange="setFilter('<?=$z->table_name ?>','<?=$_REQUEST['userID'] ?>','AddFilter2Bis',this.value)" /></td>
<td class="editUserFilter" onclick="showFilter('<?=$_REQUEST['userID']?>','<?=$z->table_name ?>','<?=$z->table_name ?>UserFilter2')">&nbsp;?&nbsp;</td>

</tr>
<?php 
}
?>
</tbody>
</table>
</div>
<?php 
}
?>
</body>
</html>