<?php
/**
 * Projekt: WS-Reporter
 *          Einen Get-Link mit den Parametern für alle gesetzten Filter produzieren
 *
 * Autor:    Wilfried Schollenberger
 *           WS Unternehmensberatung und Controlling-Systeme GmbH
 * Kontakt:  wisch@ws-unternehmensberatung.de
 * Lizenz:   GPL 3.0
 *
 * Stand:    24.05.2022
 *
 */
include 'includes/defender.inc';
require_once './includes/funktionen.inc';
require_once './includes/classes.inc';
global  $query;

$query = null;
if (session_status() == PHP_SESSION_NONE)  session_start();
anmeldungPruefen();

if (array_key_exists('WSReportQuery', $_SESSION)){
    $query = $_SESSION['WSReportQuery'];
}
session_abort();

rechteZuruecksetzen();

/* Export erlauben, damit Admin neuen Report importieren kann
if (!dqAdminRechte()){
    http_response_code(425);
    echo "Für diese Operation sind die Administrator-Rechte \nfür die Datenquelle erforderlich";
    die;
}
*/
header("Content-Type: text/plain; charset=UTF-8");
header("Content-Disposition: attachment; filename=\"Get-Link-".$query->title.'-'.date_create('now')->format('Y-m-d').".txt\"");

if ($query == null){
    echo "FEHLER:<br>Keine Report-Anforderung gefunden.";
    die();
}

// var_dump($_REQUEST);
if (false) $query = new Query("dummy");
echo $_SERVER['HTTP_HOST'];
echo str_replace('/getLink.php', '', $_SERVER['REQUEST_URI']);
echo '/outputReport.php?report='.urlencode($query->title);
$fCount=0;
/*   Normale Filter nicht im Link aufnehmen
for ($i=0; $i < $query->repFilter->size(); $i++){
    $filter = $query->repFilter->getPos($i);
    if ($filter->isSet()){
        echo "&filter{$fCount}=".urlencode($filter->getName());
        if (isValid($filter->fs_von)) echo "&filterValue{$fCount}V1=".urlencode($filter->fs_von);
        if (isValid($filter->fs_bis)) echo "&filterValue{$fCount}V2=".urlencode($filter->fs_bis);
//        echo "\n";
        $fCount ++;
    }
}
*/
for ($i=0; $i < $query->addFilter->size(); $i++){
    $filter = $query->addFilter->getPos($i);
    if ($filter->isSet()){
        echo "&filter{$fCount}=".urlencode($filter->getName());
        if (isValid($filter->fs_von)) echo "&filterValue{$fCount}V1=".urlencode($filter->fs_von);
        if (isValid($filter->fs_bis)) echo "&filterValue{$fCount}V2=".urlencode($filter->fs_bis);
//        echo "\n";
        $fCount ++;
    }
}
echo "&addFilter={$fCount}\n";
