<?php
/**
 * Projekt: WS-Reporter
 *          Metadaten-Attribute eingeben bei der Spezifikation der Datenquellen
 *
 * Autor:    Wilfried Schollenberger
 *           WS Unternehmensberatung und Controlling-Systeme GmbH
 * Kontakt:  wisch@ws-unternehmensberatung.de
 * Lizenz:   GPL 3.0
 *
 * Stand:    21.02.2023
 *
 */

require_once './includes/eqTest.inc';
global $query;
if ($query->qEditSubject <= 0 || !isValid($query->qEditVar)){
    http_response_code(425);
    echo "setMetaAttrib: Ungültiger Aufruf \nqEditSubject=$query->qEditSubject qEditVar=$query->qEditVar";
    return;
}
$attrib = $_REQUEST['attribute'];
$value = $_REQUEST['value'];
// error_log(print_r($_REQUEST,true));

if (false) $metaRecord = new MetaRecord();
$metaRecord = $query->metaData[$query->qEditVar];
if ($metaRecord == null){
    http_response_code(425);
    echo "setMetaAttrib: Keine Metadaten für $query->qEditVar";
    return;
}
if (false)$metaRecord = new MetaRecord();
if (0 == strcmp($attrib,"editSubject")) {
    // umhängen
    $arr = null;
    switch($query->qEditSubject){
        case 1: $arr = &$query->rowVars;
        break;
        case 2: $arr = &$query->valueVars;
        break;
        case 3: $arr = &$query->filterVars;
        break;
    }
    if ($arr == null || $value > 3){
        http_response_code(425);
        echo "setMetaAttrib: Fehler im Aufruf\n";
        echo var_dump($_REQUEST);
        return;
        
    }
    $found = false;
    for ($i = 0; $i < count($arr); $i++){
        if (strcmp($query->qEditVar, $arr[$i]) == 0){
            $found = true;
        }else
        if($found){
            $arr[$i-1] = $arr[$i];
        }
    }   
    if ($found) unset($arr[count($arr)-1]);
    else{
        http_response_code(425);
        echo "Variable $query->qEditVar in Quelle $query->qEditSubject nicht gefunden\n";
        echo var_dump($arr);
    }
   
    echo $query->qEditSubject;
    $query->qEditSubject = $value;
    switch($query->qEditSubject){
        case 1: $query->rowVars[] = $query->qEditVar;
        break;
        case 2: $query->valueVars[] = $query->qEditVar;
        break;
        case 3: $query->filterVars[] = $query->qEditVar;
        break;
    }
    
    return;
}
if (0 == strcmp($attrib,"label")) {
    $metaRecord->label = $value;
    echo $query->qEditSubject;
    return;
}
if (0 == strcmp($attrib,"description")) {
    $metaRecord->description = $value;
    return;
}
if (0 == strcmp($attrib,"hints")) {
    $metaRecord->hints = $value;
    return;
}
if (0 == strcmp($attrib,"type")) {
    $oldType = $metaRecord->type;
    $metaRecord->type = $value;
    
    if ($value == MetaRecord::HISTAB) {
        $query->histAb = $metaRecord->getName();
        $metaRecord->type = MetaRecord::DATE;
    }
    else if ($value == MetaRecord::HISTBIS) {
        $query->histBis = $metaRecord->getName();
        $metaRecord->type = MetaRecord::DATE;
    }
    else if ($value == MetaRecord::HISTSTICHTAG) {
        $query->histStichtag = $metaRecord->getName();
        $metaRecord->type = MetaRecord::DATE;        
    }
    if ($oldType == MetaRecord::HISTDEL || $value == MetaRecord::HISTDEL) return 11;
    return;
}

if (0 == strcmp($attrib,"htmlData")) {
    $metaRecord->htmlData = $value;
    return;
}
if (0 == strcmp($attrib,"align")) {
    $metaRecord->align = $value;
    return;
}
if (0 == strcmp($attrib,"decimals")) {
    $metaRecord->decimals = $value;
    return;
}
if (0 == strcmp($attrib,"selectVar")) {
    testSelect($value);
    $metaRecord->selectVar = $value;
    return;
}
if (0 == strcmp($attrib,"displayVar")) {
    testSelect($value);
    $metaRecord->displayVar = $value;
    return;
}
if (0 == strcmp($attrib,"filterType")) {
    $metaRecord->filterType = $value;
    return;
}
if (0 == strcmp($attrib,"dimNr")) {
    $metaRecord->dimNr = 1*$value;
    return;
}
if (0 == strcmp($attrib,"filterRequired")) {
    if ($value == "true") $metaRecord->filterRequired = true;
    else $metaRecord->filterRequired = false;
    
    return;
}
if (0 == strcmp($attrib,"filterSort")) {
    $metaRecord->filterSort = 1 * $value;
    return;
}
if (0 == strcmp($attrib,"filterRequiredGroup")) {
//    error_log("filterRequiredGroup = {$value}\n");
    if ($value > 0) {
        $metaRecord->filterRequired = true;
        $metaRecord->filterRequiredGroup = $value;
    }
    else {
        $metaRecord->filterRequired = false;
        $metaRecord->filterRequiredGroup = 0;
    }
    
    return;
}
if (0 == strcmp($attrib,"enterValue")) {
    if ($value == "true") $metaRecord->enterValue = true;
    else $metaRecord->enterValue = false;    
    return;
}
if (0 == strcmp($attrib,"enterValueSize")) {
    $metaRecord->enterValueSize = (int) $value;
    return;
}


if (0 == strcmp($attrib,"qSetVarname")) {
    testSelect($value);
    $metaRecord->qSetVarname = $value;
    return;
}
if (0 == strcmp($attrib,"selectFilterTable")) {
    $metaRecord->selectFilterTable = $value;
    if (isValid($value) && substr(trim($value),0,1) == '#'){
        $metaRecord->selectFilterTable2 = null;
        $metaRecord->selectFilterVar = null;
        $metaRecord->selectFilterVar2 = null;
    }
    return;
}
if (0 == strcmp($attrib,"selectFilterVar")) {
    $metaRecord->selectFilterVar = $value;
    return;
}
if (0 == strcmp($attrib,"selectFilterTable2")) {
    $metaRecord->selectFilterTable2 = $value;
    return;
}

if (0 == strcmp($attrib,"selectFilterVar2")) {
    $metaRecord->selectFilterVar2 = $value;
    return;
}
if (0 == strcmp($attrib,"chartColor")) {
    $metaRecord->chartColor = $value;
    return;
}
if (0 == strcmp($attrib,"chartNegColor")) {
    $metaRecord->chartNegColor = $value;
    return;
}
if (0 == strcmp($attrib,"chartGroup")) {
    $metaRecord->chartGroup = $value;
    return;
}
if (0 == strcmp($attrib,"chartMin")) {
    $metaRecord->chartMin = $value;
    return;
}
if (0 == strcmp($attrib,"chartMax")) {
    $metaRecord->chartMax = $value;
    return;
}
if (strpos($attrib,'setHidden') === 0){
    if ($value == 'false') $metaRecord->hidden = false;
    if ($value == 'true') $metaRecord->hidden = true;
    return;
}
if (strpos($attrib,'setDimReq') === 0){
    $nr = 1*substr($attrib, 9);
    $p = array_search($nr,$metaRecord->reqDim);
    if ($p !== false && $value == 'false') unset ($metaRecord->reqDim[$p]);
    if ($p === false && $value == 'true') $metaRecord->reqDim[] = $nr;
    
    return;
}

if (strpos($attrib,'rename') === 0){
    error_log('Rename '.$query->qEditVar.' to '.$value);
    if ($query->qEditVar == $value) {
        return;
    }
    if (array_key_exists($value, $query->metaData)){
        http_response_code(425);
        echo 'Name schon vergeben';
        die();
    }
    $arr = null;
    switch($query->qEditSubject){
        case 1: $arr = &$query->rowVars;
        break;
        case 2: $arr = &$query->valueVars;
        break;
        case 3: $arr = &$query->filterVars;
        break;
    }
    if ($arr == null || $value > 3){
        http_response_code(425);
        echo "setMetaAttrib: Fehler im Aufruf\n";
        echo var_dump($_REQUEST);
        return;    
    }
    $p = array_search($query->qEditVar, $arr);
    if ($p!== false) $arr[$p] = $value;
    /*
     * Vor dem Umbenennen müssen ggf. Selectoptions aus queryMetadataSelectOptions
     * eingelesen werden.
     */
    if ($metaRecord->hasMetadataSelectOptions()) $metaRecord->getSelectOptions();
    foreach ($query->dimensions as $dim)
        if ($dim->baseKey == $query->qEditVar) $dim->baseKey = $value;
    $metaRecord->setColumnName($value);
    $query->metaData[$value] = $metaRecord;
    unset ($query->metaData[$query->qEditVar]);
    $query->qEditVar = $value;
    return;
}


http_response_code(425);
echo "setAttrib: Unbekanntes MetaRecord-Attribut: $attrib";
return;