<?php
/**
 * Projekt: WS-Reporter
 *          Ausgabe der globalen Attribute des Report-Editors
 *
 * Autor:    Wilfried Schollenberger
 *           WS Unternehmensberatung und Controlling-Systeme GmbH
 * Kontakt:  wisch@ws-unternehmensberatung.de
 * Lizenz:   GPL 3.0
 *
 * Stand:    21.6.2022 ms
 *
 */
require_once './includes/wsrTranslate.inc';
?>

    <?= WSRTranslate::translate('Überschrift')?>: <input type="text" name="title" value="<?=$query->title?>" 
           onchange="setQAttribute('title',this.value);unhideNewReport()" id="title" size="60">
<?php 
if (isValid($query->table_hints)){
    echo "\n<br><b>".WSRTranslate::translate('Technische Hinweise zur Datenquelle').":</b><br>\n";
    echo quoteForHTML($query->table_hints),'<br>';
}
?>           
    <br>
    <b><?= WSRTranslate::translate('Optionen')?>:</b><br>
    <input type="checkbox" onchange="setQAttribute('fix_labelColumns',this.checked)"  
    <?=$query->getFixLabelColumnsChecked() ?>/> <?= WSRTranslate::translate('Zeilen-Label fixieren')?>
    &nbsp;&nbsp;&nbsp;&nbsp;<?= WSRTranslate::translate('Auf- und Zuklappen')?>: 
    <select onchange="setQAttribute('folderMode',this.value)">
    <option value="<?=Query::KEINE ?>"  <?=checkSel($query->folderMode,Query::KEINE  ) ?>><?=Query::getFolderText(Query::KEINE )?></option>
    <?php
    if ($query->sort_mode != SortOptions::SORTTABLE){
    ?>
    <option value="<?=Query::FOLDEROFFEN ?>" <?=checkSel($query->folderMode,Query::FOLDEROFFEN  ) ?>><?=Query::getFolderText(Query::FOLDEROFFEN )?></option>
    <option value="<?=Query::FOLDERZU ?>" <?=checkSel($query->folderMode,Query::FOLDERZU  ) ?>><?=Query::getFolderText(Query::FOLDERZU )?></option>
    <option value="<?=Query::FOLDERZU1 ?>" <?=checkSel($query->folderMode,Query::FOLDERZU1  ) ?>><?=Query::getFolderText(Query::FOLDERZU1 )?></option>
    <option value="<?=Query::FOLDERZU2 ?>" <?=checkSel($query->folderMode,Query::FOLDERZU2  ) ?>><?=Query::getFolderText(Query::FOLDERZU2 )?></option>
    <option value="<?=Query::FOLDERERSTEZEILE ?>" <?=checkSel($query->folderMode,Query::FOLDERERSTEZEILE  ) ?>><?=Query::getFolderText(Query::FOLDERERSTEZEILE )?></option>
    <?php
    }
    ?>
    </select>
    <br><?= WSRTranslate::translate('Sortier-Option in Ausgabe')?>:
    <select onchange="setQAttribute('sort_mode',this.value)">
    <option value="<?=SortOptions::NOSORTVAL ?>"     <?=checkSel($query->sort_mode,SortOptions::NOSORTVAL ) ?>><?= WSRTranslate::translate('keine Sortierung möglich')?></option>
    <option value="<?=SortOptions::SORTLASTGROUP ?>" <?=checkSel($query->sort_mode,SortOptions::SORTLASTGROUP ) ?>><?= WSRTranslate::translate('in der letzten Gruppe')?></option>
    <?php
    if ($query->folderMode == Query::KEINE ){
    ?>
    <option value="<?=SortOptions::SORTTABLE ?>"     <?=checkSel($query->sort_mode,SortOptions::SORTTABLE ) ?>><?= WSRTranslate::translate('ganze Tabelle')?></option>
    <?php
    }
    ?>
    <option value="<?=SortOptions::SORTSPECIAL ?>"   <?=checkSel($query->sort_mode,SortOptions::SORTSPECIAL ) ?>><?= WSRTranslate::translate('alle Gruppen in der Tabelle')?></option>
    <option value="<?=SortOptions::SORTSPECIALSZ ?>"   <?=checkSel($query->sort_mode,SortOptions::SORTSPECIALSZ ) ?>><?= WSRTranslate::translate('alle Summenzeilen in der Tabelle')?></option>
    </select>
    <br>
    <?= WSRTranslate::translate('Chart-Größe')?>:
    <select onchange="setQAttribute('chart_size',this.value)">
    <option value="1em" <?=checkSel("1em", $query->chart_size) ?>><?= WSRTranslate::translate('sehr klein')?></option>
    <option value="2em" <?=checkSel("2em", $query->chart_size) ?>><?= WSRTranslate::translate('klein')?></option>
    <option value="3em" <?=checkSel("3em", $query->chart_size) ?>><?= WSRTranslate::translate('mittel')?></option>
    <option value="4em" <?=checkSel("4em", $query->chart_size) ?>><?= WSRTranslate::translate('groß')?></option>
    <option value="5em" <?=checkSel("5em", $query->chart_size) ?>><?= WSRTranslate::translate('sehr groß')?></option>
    
    </select>
    &nbsp;&nbsp; <?= WSRTranslate::translate('Charts anzeigen')?>:
    <select onchange="setQAttribute('display_charts',this.value)">
    <option value="<?=ChartOptions::KEINESUMMEN ?>" <?=checkSel(ChartOptions::KEINESUMMEN, $query->display_charts) ?>><?= WSRTranslate::translate('keine Summen')?></option>
    <option value="<?=ChartOptions::NURSUMMEN ?>" <?=checkSel(ChartOptions::NURSUMMEN, $query->display_charts) ?>><?= WSRTranslate::translate('nur Summen')?></option>
    <option value="<?=ChartOptions::IMMER ?>" <?=checkSel(ChartOptions::IMMER, $query->display_charts) ?>><?= WSRTranslate::translate('immer')?></option>
    
    </select>
    <br>
    <?= WSRTranslate::translate('Geldbeträge')?> 
    <select onchange="setQAttribute('repGeldFaktor',this.value)">
    <option value="1"     <?=checkSelN($query->repGeldFaktor,1 ) ?>><?= WSRTranslate::translate('in €')?></option>
    <option value="0.001" <?=checkSelN($query->repGeldFaktor,0.001 ) ?>><?= WSRTranslate::translate('in Tsd.€')?></option>
    <option value="0.000001"     <?=checkSelN($query->repGeldFaktor,0.000001 ) ?>><?= WSRTranslate::translate('in Mio.€')?></option>
    </select>
    &nbsp;&nbsp;&nbsp;&nbsp;
    <input type="checkbox" name="dropSummen" onchange="setQAttribute('dropSummen',this.checked)"   
    <?php if ($query->dropSummen) echo ' checked="checked" '; ?> 
      /> <?= WSRTranslate::translate('redundante Summenzeilen leer lassen')?>

<?php 
if ($query->hatWerteAuswahl){
?>
    <br>
<span class='help' title= 
"<?= WSRTranslate::translate('Diese Datenquelle unterstützt die Option Werte-Auswahl.
Sie können den Report für eine Gruppe von Werten, z.B. Bruttoertrag,
erstellen und diese Werte dann bei der Report-Ausgabe durch andere Werte, 
z.B. Nettoertrag, ersetzen.
Dazu müssen Sie hier angeben, für welchen Wert Sie dien Report erstellen.')?>" 
><?= WSRTranslate::translate('Werte-Auswahl Basiswert')?></span>    
<select onchange="setQAttribute('repWerteBasis',this.value);load('Filter')">
<option value='' <?php if ($query->repWerteBasis == null) echo 'selected';?>><?= WSRTranslate::translate('-- nicht aktiv --')?></option>
<?php 
$mr = $query->getReportMetaRecord('WSR_WERTELISTE');
if ($mr != null){
    $liste = $mr->getSelectOptions();
    foreach ($liste as $wert ){
?>
<option value='<?=$wert[0] ?>' <?= checkSel($wert[0], $query->repWerteBasis)?>><?=$wert[1] ?></option>
<?php
    }
}
?>
</select>
<?php 
}
?>
    
    <br><b class="top"><?= WSRTranslate::translate('Kommentar')?>:</b>
    <textarea rows="5" cols="100" id="Kommentar" name="Kommentar" onchange="setQAttribute('kommentar',this.value)"><?=
    quoteForText($query->kommentar) ?></textarea>
    <br>
    <br><b class="top"><?= WSRTranslate::translate('Technische Hinweise')?>:</b>
    <textarea rows="5" cols="100" id="Hints" name="Hints" onchange="setQAttribute('report_hints',this.value)"><?=
    quoteForText($query->report_hints) ?></textarea>
    <br>
    <b><?= WSRTranslate::translate('Sprache')?>:</b> <?=qTranslate::sprache($query->rLanguage) ?>&nbsp;&nbsp;&nbsp;
    <?= WSRTranslate::translate('Übersetzungen')?>:
    <?php
foreach ( qTranslate::SPRACHEN as $l)
    if ($l != $query->rLanguage
        && ($l == $query->qLanguage || false !== array_search($l, $query->qTranslations))){
    $check = '';
    if (false !== array_search($l, $query->rTranslations)) $check = 'checked';
?>
<input type="checkbox" <?=$check ?> onchange="setQAttribute('translation_<?=$l ?>',this.checked)" /> 
<?= qTranslate::sprache($l) ?>
<?php 
}
?>
    
    <br>
    <div class="nav inlineBox" onclick="showHide('Alle')"><?= WSRTranslate::translate('Alles anzeigen')?></div>
    <div class="nav inlineBox" onclick="showHide('XSpezZeilen')"><?= WSRTranslate::translate('Zeilen')?></div>
    <div class="nav inlineBox" onclick="showHide('XSpezWerte')"><?= WSRTranslate::translate('Werte')?></div>
        <div class="nav inlineBox" onclick="showHide('XSpezSpalten')"><?= WSRTranslate::translate('Spalten')?></div>
    <div class="nav inlineBox" onclick="showHide('XSpezFilter')"><?= WSRTranslate::translate('Filter')?></div>
    <?php
    if ($query->addQueries != null && $query->addQueries->size() > 0){
        ?>
        <div class="nav inlineBox" onclick="showHide('XSpezJoinVrz')"><?= WSRTranslate::translate('Quellen')?></div>
        <?php
    }
    ?>
    <div class="nav inlineBox" onclick="showHide('XQuellenDesc')"><?= WSRTranslate::translate('Quellen-Beschreibung')?></div>
            <div class="nav inlineBox" onclick="showHide('XReportVerweise')"><?= WSRTranslate::translate('Report-Verweise')?></div>
    <div class="nav inlineBox" onclick="showHide('XReports')"><?= WSRTranslate::translate('Reports')?></div>    