<?php
/**
 * Projekt: WS-Reporter
 *          Startseite mit Anmeldung und Prüfung der Benutzer-Rechte
 *
 * Autor:    Wilfried Schollenberger
 *           WS Unternehmensberatung und Controlling-Systeme GmbH
 * Kontakt:  wisch@ws-unternehmensberatung.de
 * Lizenz:   GPL 3.0
 *
 * Stand:    14.9.2022
 *
 */
require_once 'includes/defender.inc';
require_once 'includes/funktionen.inc';
require_once './includes/wsrTranslate.inc';
require_once './includes/qTranslate.inc';

if (session_status() == PHP_SESSION_NONE)  session_start();
/*
if (array_key_exists('Token', $_SESSION)){
    $token = $_SESSION['Token'];
    if (array_key_exists('WS-Report-Token', $_COOKIE)){
        if ($token != $_COOKIE['WS-Report-Token']){
            echo "FEHLER: Das Anmelde-Token passt nicht.<br>Die Anwendung wird gesperrt.<br>".$token.' != '.$_COOKIE['WS-Report-Token'];
            die();
        }
    }
}
*/
$token = hrtime(true);
setcookie('WS-Report-Token',$token,['SameSite' => "Strict", 'path' => '/'] );
$_SESSION['Token'] = $token;
if (isset($_SESSION['TIcons'])) unset($_SESSION['TIcons']);

if (array_key_exists('todo', $_REQUEST)
    && $_REQUEST['todo'] == "Abmelden"){
        if (array_key_exists('globalAdmin', $_SESSION)) unset($_SESSION['globalAdmin']);
        if (array_key_exists('User', $_SESSION)) unset($_SESSION['User']);
        if (array_key_exists('Name', $_SESSION)) unset($_SESSION['Name']);
        if (array_key_exists('Rechte', $_SESSION)) unset($_SESSION['Rechte']);
        if (array_key_exists('Sprache', $_SESSION)) unset($_SESSION['Sprache']);
        if (array_key_exists('WSReportQuery', $_SESSION)) unset($_SESSION['WSReportQuery']);
        session_write_close();
}else if (array_key_exists('User', $_SESSION) && !array_key_exists('user', $_REQUEST)){
    $user = $_SESSION['User'];
    if (array_key_exists('uLanguage', $_REQUEST) && isValid($_REQUEST['uLanguage'])) {
        $_SESSION['Sprache'] = $_REQUEST['uLanguage'];
        if (array_key_exists('TIcons', $_REQUEST)) $_SESSION['TIcons'] = true;
            
    }
    session_write_close();
}else{
    include './includes/anmelden.inc';    
}


if (isset($user)){
    $part = "Angemeldet";
    if (file_exists('./phpsec/index.inc')){
        include './phpsec/index.inc';
    }else{
        include './phpsec/index-fallback.inc';
    }
?>

<p><?=WSRTranslate::translateH('Anmeldung')?> <?=$_SESSION['Name'] ?></p>
<p><?=WSRTranslate::translateH('Folgende Aufrufe sind aktuell verfügbar')?>:</p>
<ul>
<?php
if (array_key_exists('reports', $_SESSION) && count($_SESSION['reports']) > 0){
?>
<li><b><a href="./outputReport.php?report=<?=$_SESSION['reports'][0]?>" target="Report"
	><?=WSRTranslate::translateH('Startseite')?></a></b></li>
<?php 
}
?>
<li><a href="./outputReport.php?report=<?=qTranslate::translateReportTitle('Report-Verzeichnis') ?>" target="Report-Verzeichnis"
	><?=WSRTranslate::translateH('Report-Verzeichnis')?></a></li>
<?php 
if (! array_key_exists('EndUser', $_SESSION) || ! $_SESSION['EndUser']){
?>
<li><a href="./editQuery.php?vrz=x&Auswahl0=1&Auswahl1=1&Auswahl=A" target="WS-QEditor"
	><?=WSRTranslate::translateH('Verzeichnis der Datenquellen')?></a></li>
<?php 
}
?>
<li><a href="./anleitung.php?level=10" target="WS-Anleitung"><?=WSRTranslate::translateH('Anleitung allgemein')?></a></li>
</ul>
<?php 
if ($_SESSION['globalAdmin']){    
?>
<details>
<summary><?=WSRTranslate::translateH('Administration')?></summary>
<ul>
<li><a href="./editUser.php" target="editUser"><?=WSRTranslate::translateH('Benutzerverwaltung')?></a>
<li><a href="./editRollen.php" target="editRollen"><?=WSRTranslate::translateH('Rollenverwaltung und Reports')?></a>
<li><a href="./testGlobal.php" target="TestGlobal"><?=WSRTranslate::translateH('Globale Prüfungen')?></a>
<?php if ($_SERVER["HTTP_HOST"] == "localhost:8898"){?>
<li><a href="./translateWS-Reporter.php" target="TranslateWSR"><?=WSRTranslate::translateH('WS-Reporter übersetzen')?></a>
<li><a title='Datenquellen und Reports für das Report-Verzeichnis aus phpsec/reports importieren'
href="./wsrReportvrzImportieren.php" target="ImportVrz"><?=WSRTranslate::translateH('Report-Verzeichnis importieren')?></a>
<?php } else{ ?>
<li><a title='Eine neue Übersetzung aus der Datei phpsec/wsrTranslations.sql einlesen' 
href="./translateEinlesen.php" target="TranslateWSR"><?=WSRTranslate::translateH('Übersetzung für WS-Reporter einlesen')?></a>
<li><a title='Datenquellen und Reports für das Report-Verzeichnis aus ./reports importieren'
href="./wsrReportvrzImportieren.php" target="ImportVrz"><?=WSRTranslate::translateH('Report-Verzeichnis importieren')?></a>
</ul>

<?php
}
?>
</details>
<?php
}
?>

<?php 
if (array_key_exists('Sprache', $_SESSION)) $sprache = $_SESSION['Sprache'];
else $sprache = 'de';

?>
<br><?=WSRTranslate::translateH('Neu anmelden oder abmelden')?>:
<form action="./index.php" method="post">
<br><?=WSRTranslate::translateH('Benutzername')?>: <input type="text" name="user" autocomplete="off"/>
<br><?=WSRTranslate::translateH('Passwort')?>: <input type="password" name="pass" />
<br><input type="submit" name = "todo" value="<?=WSRTranslate::translate('Anmelden')?>" />
<input type="submit" name = "todo" value="<?=WSRTranslate::translate('Abmelden')?>" />
</form>
<br>
<br><?=WSRTranslate::translateH('Sprache').' '.$sprache. ' '.WSRTranslate::translateH('wechseln')?>:
<form action="./index.php" method="post">
<br><?=WSRTranslate::translateH('Sprache')?>: <select name="uLanguage">
<option value="de" <?php if ($sprache == 'de') echo 'selected' ?>>Deutsch</option>
<option value="en" <?php if (substr($sprache,0,2) == 'en') echo 'selected' ?>>English</option>
<option value="fr en" <?php if (substr($sprache,0,2) == 'fr') echo 'selected' ?>>Francais</option>
</select>
<?php 
if ($_SESSION['globalAdmin']){  
?>
<input type="checkbox" name="TIcons"> <?=WSRTranslate::translateH('Mit Icons für Übersetzung')?>
<?php 
}
?>
<br><input type="submit" name = "sub" value="<?=WSRTranslate::translate('Wechseln')?>" />
</form>
<?php 
?>
</body>
</html>
<?php 
}else{
    $part = "Anmeldung";
    if (file_exists('./phpsec/index.inc')){
        include './phpsec/index.inc';
    }else{
        include './phpsec/index-fallback.inc';
    }

    if (isset($meldung)) echo $meldung.'<br>'?>

<form action="./index.php" method="post">
<br><?=WSRTranslate::translateH('Benutzername')?>: <input type="text" name="user" />
<br><?=WSRTranslate::translateH('Passwort')?>: <input type="password" name="pass" />
<br><input type="submit" value="<?=WSRTranslate::translateH('Anmelden')?>" />
</form>
<br>
<a href="./anleitung.php?level=11&part=index" target="WS-Anleitung"><?=WSRTranslate::translateH('Anleitung allgemein')?></a>
<br>

<?php 
}
$part = "Ende";
if (file_exists('./phpsec/index.inc')){
    include './phpsec/index.inc';
}else{
    include './phpsec/index-fallback.inc';
}
?>