/**
 * Projekt: WS-Reporter
 *			JavaScript für Spezifikation von Datenquellen
 *
 * Autor:    Wilfried Schollenberger
 *           WS Unternehmensberatung und Controlling-Systeme GmbH
 * Kontakt:  wisch@ws-unternehmensberatung.de
 * Lizenz:   GPL 3.0
 *
 * Stand:    31.05.2022
 * 
 *
 * call = editQuery.php mit den Parametern id=requestID und table=requestTable
*/

function anleitung(level,part){
  win = open("./anleitung.php?level="+level+'&part='+encodeURIComponent(part),
  "WSRAnleitung",
  "width=900,height=700,screenX=500,screenY=300,scrollbars=yes");
}

function clearSelectOptions(){
	var request = new XMLHttpRequest();
	request.open("GET",call+"&set=SelectOptions"); // ,false);
	request.addEventListener('load', function(event) {
		   if (request.status == 200) {
				document.getElementById("Editor").style.display = "block";
				document.getElementById("SelectWerte").style.display = "none";
			} else if (request.status == 425) {						
					alert("Fehler bei clearSelectOptions\n"+request.responseText);													
		   } else {
			      // console.warn
				alert("clearSelectOptions\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send();				
}

function clearValueList(){
	var request = new XMLHttpRequest();
	request.open("GET",call+"&set=ValueList"); // ,false);
	request.addEventListener('load', function(event) {
		   if (request.status == 200) {
				document.getElementById("SelectWerte").style.display = "none";
			} else if (request.status == 425) {						
					alert("Fehler bei clearValueList\n"+request.responseText);													
		   } else {
			      // console.warn
				alert("clearValueList\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send();				
}

function closeDimVars(){
	var request = new XMLHttpRequest();
	request.open("GET",call+"&set=QueryActions&action=selectDimension&selectDimension=-1"); // ,false);
	request.addEventListener('load', function(event) {
		   if (request.status == 200) {
					 	document.getElementById("SelectWerte").style.display = "none";						
			} else if (request.status == 425) {						
					  alert("Fehler beim Schließen der Dimension\n"+request.responseText);						
				 } else {
			      // console.warn
				alert("showDimensionVars\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send();				
	return;		
	
}

function closeEditor(){
	document.getElementById("Editor").style.display = "none";
}

function closeJoinWerte(){
	document.getElementById("JoinWerte").style.display = "none";
}


function closeMuster(wo){
	var request = new XMLHttpRequest();
	request.open("GET",call+"&set=CloseMuster"); // ,false);
	request.addEventListener('load', function(event) {
		   if (request.status == 200) {
					  loadNrF(wo,null);		  
			} else if (request.status == 425) {						
					  alert("Fehler beim Schließen der Muster-Auswahl\n"+request.responseText);						
				 } else {
			      // console.warn
				alert("closeMuster\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send();				

}

function closeQueryEditor(){
	var request = new XMLHttpRequest();	
	document.getElementById("QueryEditor").style.display = "none";
	document.getElementById("JoinWerte").style.display = "none";
	request.open("GET",call+"&set=JoinMetaEditor&pos=0"); // ,false);
	request.addEventListener('load', function(event) {
		   if (request.status == 200) {
			} else if (request.status == 425) {						
					  alert("Fehler bei editQuery\n"+request.responseText);													
		   } else {
			      // console.warn
				alert("editQuery\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send();				

}


function closeSelectOptions(){
	document.getElementById("Editor").style.display = "block";
	document.getElementById("SelectWerte").style.display = "none";
}
function closeValueList(){
	document.getElementById("SelectWerte").style.display = "none";
}


function deleteClass(closeWindow){
	if (confirm("Bitte bestätigen Sie das Löschen der Datenquelle")){
		var request = new XMLHttpRequest();
		request.open("GET",call+"&set=QueryActions&action=deleteClass"); // ,false);
		request.addEventListener('load', function(event) {
			   if (request.status == 200) {
						alert(request.responseText);
						window.close();						
				} else if (request.status == 425) {						
						  alert("Fehler beim Löschen des Objekts\n"+request.responseText);						
					 } else {
				      // console.warn
					alert("deleteClass\n"+request.statusText+" "+ request.status
					+"\n"+request.responseText);
				   }
				});
		request.send();				
	}
	return false;		
}


function delVar(wo,pos){
	var request = new XMLHttpRequest();
	request.open("GET",call+"&set=ActionPos&action=delete&wo="+wo+"&pos="+pos); // ,false);
	request.addEventListener('load', function(event) {
		   if (request.status == 200) {
				loadNrF(wo);
				if (wo == 5){
				loadNrF(1);
				loadNrF(3);					
				}
			} else if (request.status == 425) {						
					  alert("Fehler beim Löschen:\n"+request.responseText);						
				 } else {
			      // console.warn
				alert("delVar\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send();				

}


function editJoinedQuery(pos){
	var request = new XMLHttpRequest();
	request.open("GET",call+"&set=JoinMetaEditor&pos="+pos); // ,false);
	request.addEventListener('load', function(event) {
		   if (request.status == 200) {
//					  var editor = document.getElementById("QueryEditor"); 
//					  editor.style.display="block";
					loadNrF(100);	
					loadNrF(101);	
//					selectJoinWerte(pos);
			} else if (request.status == 425) {						
					  alert("Fehler bei editQuery\n"+request.responseText);													
		   } else {
			      // console.warn
				alert("editQuery\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send();				
}

function editVar(wo,pos){
	var request = new XMLHttpRequest();
	//   consle.log("Aufruf:"+call+"&set=ActionPos&action=editVar&wo="+wo+"&pos="+pos);
	request.open("GET",call+"&set=ActionPos&action=editVar&wo="+wo+"&pos="+pos); // ,false);
	request.addEventListener('load', function(event) {
		   if (request.status == 200) {
					  loadNrF(11);
			} else if (request.status == 425) {						
					  alert("Fehler bei editVar\n"+request.responseText);													
		   } else {
			      // console.warn
				alert("editVar\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send();				

}

/* umgestellt */
function enterSelectOptions(){
	var request = new XMLHttpRequest();
	request.open("GET",call+"&get=SelectOptions"); // ,false);
	request.addEventListener('load', function(event) {
		   if (request.status == 200) {
					document.getElementById("Editor").style.display = "none";
					document.getElementById("SelectWerte").style.display = "block";
					document.getElementById("SelectWerte").innerHTML = request.responseText;
			} else if (request.status == 425) {						
					alert("Fehler bei enterSelectOptions\n"+request.responseText);													
		   } else {
			      // console.warn
				alert("editVar\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send();				
}

function enterValueList(){
	var request = new XMLHttpRequest();
	request.open("GET",call+"&get=ValueList"); // ,false);
	request.addEventListener('load', function(event) {
		   if (request.status == 200) {
					document.getElementById("Editor").style.display = "none";
					document.getElementById("SelectWerte").style.display = "block";
					document.getElementById("SelectWerte").innerHTML = request.responseText;
			} else if (request.status == 425) {						
					alert("Fehler bei enterValueList\n"+request.responseText);													
		   } else {
			      // console.warn
				alert("editVar\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send();				
}


function exportClass(){
	var fo = document.getElementById("saveForm");
	fo.action = "./exportQuery.php"
	fo.target="";
	fo.submit();
	return false;		
}


/**
 * Hilfsprogramm für Bearbeitung der Selection-Liste
 */

function findeRow(rows,rowItem,name){
	for (i = 0; i < rows.length; i++){
		var r = rows.item(i);
		var e = r.children;
		for (ic = 0; ic < e.length; ic ++ ){
			if (e.item(ic) === rowItem ) {
			return(i);
		}
		}
	}
	return -1;	
}

var selFocus = null;

function focusNewSel(source){
	if (source === selFocus){
		document.getElementById("selOptionsNew").focus();
	}
}

function hideShow(anzeige,show){
	var ziel = document.getElementById(anzeige);
			//   consle.log('Ziel'+ziel.style.display);
	if (show){
		ziel.style.display='table-row-group';
		//   consle.log(show+'=Inherit '+anzeige);
	}else{
		ziel.style.display='none';
		//   consle.log(show+'=Hide '+anzeige+' - '+ziel);
	}
}


function hideShowAll(anzeige,show){
	for (var i = 0; true; i++){
		var ziel = document.getElementById(anzeige+i);
		if (ziel == null) return;
		if (show){
			ziel.style.display='table-row-group';
		}else{
			ziel.style.display='none';
		}
	}
}


function initDimension(pos,type){
	var request = new XMLHttpRequest();
	request.open("GET",call+"&set=ActionPos&action=initDimension&wo=5&pos="+pos+"&init="+type);
	request.addEventListener('load', function(event) {
		   if (request.status == 200) {
//			console.log("NewVar "+name.value+": "+request.responseText);
				loadNrF(1,null);
				loadNrF(3,null);
				loadNrF(5,"NV"+5);
			} else if (request.status == 425) {						
					  alert("Fehler beim Initalisieren der Dimension \n"+request.responseText);													
				 } else {
			      // console.warn
				alert("initDimension\n"+request.responseText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send();				

}

function initDimensionKey(pos,key){
	var request = new XMLHttpRequest();
	request.open("GET",call+"&set=ActionPos&action=initDimensionKey&wo=5&pos="+pos+"&key="+key);
	request.addEventListener('load', function(event) {
		   if (request.status == 200) {
//			console.log("NewVar "+name.value+": "+request.responseText);
				loadNrF(1,null);
				loadNrF(3,null);
				loadNrF(5,"NV"+5);
			} else if (request.status == 425) {						
					  alert("Fehler beim Initalisieren der Dimension \n"+request.responseText);													
				 } else {
			      // console.warn
				alert("initDimension\n"+request.responseText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send();				

}



 function loadJoinMuster(name,pos){
	var request = new XMLHttpRequest();
	request.open("GET",call+"&set=MusterVar&action=load&varName="+name); // ,false);
	request.addEventListener('load', function(event) {
		   if (request.status == 200) {
					  loadNrF(100,'show',pos);
			} else if (request.status == 425) {						
					  alert("Fehler bei loadJoinMuster\n"+request.responseText);													
		   } else {
			      // console.warn
				alert("loadJoinMuster\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send();				
 }


function loadMusterVar(){
	var request = new XMLHttpRequest();
	request.open("GET",call+"&set=MusterVar&action=load"); // ,false);
	request.addEventListener('load', function(event) {
		   if (request.status == 200) {			
				loadNrF(11);
			} else if (request.status == 425) {						
					  alert("Fehler beim Laden des Musters\n"+request.responseText);	
				 } else {
			      // console.warn
				alert("newMusterVar\n"+request.responseText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send();				
}


function loadNrF (nr,focus,pos){
//	console.log("loadNrF "+nr);
 var ziel = document.getElementById("SpezZeilen");
 var get = "get=Zeilen";
	if (nr == 0) {
 		ziel = document.getElementById("Globals");
 		get = "get=Globals";
	}else
	if (nr == 1) {
 		ziel = document.getElementById("SpezZeilen");
 		get = "get=Zeilen";
	}else
	if (nr == 2) {
		ziel = document.getElementById("SpezWerte");
		get = "get=Werte";	
	}
	else 
	if (nr == 3) {
		ziel = document.getElementById("SpezFilter");
		get = "get=Filter";	
	}  
	else 
	if (nr == 4) {
		ziel = document.getElementById("SpezAddQuery");
		get = "get=AddQuery";	
	}  
	else 
	if (nr == 5) {
		ziel = document.getElementById("SpezDimensionen");
		get = "get=Dimensionen";	
	}  
	else 
	if (nr == 6) {
		ziel = document.getElementById("SpezDefaultFilter");
		if (ziel == null) return;
		get = "get=DefaultFilter";	
	}  
	else 
	if (nr == 11) {
		ziel = document.getElementById("Editor");
  	    ziel.style.display="block";
		get = "get=MetaEditor";	
	}  
	else 
	if (nr == 12) {
		ziel = document.getElementById("SelectWerte");
  	    ziel.style.display="block";
		get = "get=Werte";	
	}  
	else 
	if (nr == 13) {
		ziel = document.getElementById("SelectWerte");
  	    ziel.style.display="block";
		get = "get=DimVars";	
	}  
	else 
	if (nr == 100) {
		ziel = document.getElementById("QueryEditor");
  	    ziel.style.display="block";		
		get = "get=JoinMetaEditor";	
	}  
	else 
	if (nr == 101) {
		ziel = document.getElementById("JoinWerteTable");
  	    document.getElementById("JoinWerte").style.display="block";
		get = "get=JoinWerte";	
	}else{
		return;
	}
	var request = new XMLHttpRequest();
	request.open("GET",call+"&"+get); // ,false);
	request.addEventListener('load', function(event) {
		   if (request.status == 200) {
				  ziel.innerHTML = request.responseText;	
				if (nr == 100 && focus == 'show'){
					ziel = document.getElementById('jm'+pos);
					if (ziel != null)
						ziel.style.display='table-row-group';
					else console.log ('jm'+(pos)+' ist null');			
				}else	
				  if (focus != null)document.getElementById(focus).focus();	
				if (nr == 11) {
					setFilterAnzeige();
					renameClose();
				} 	
			} else if (request.status == 425) {						
					  alert("Fehler beim Laden von "+nr+"\n"+request.responseText);						
				 } else {
			      // console.warn
				alert("loadNrF\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send();				
}

	
/* umgestellt  */
function newVar(wo,name){
	if (name.value == null) return;
	if (name.value.trim() == "") return;
	var request = new XMLHttpRequest();
	//   consle.log("Start newVar "+name.value);
	request.open("GET",call+"&set=NewVar&wo="+wo+"&name="+encodeURIComponent(name.value)); // ,false);
	request.addEventListener('load', function(event) {
		   if (request.status == 200) {
//			console.log("NewVar "+name.value+": "+request.responseText);
				loadNrF(wo,"NV"+wo);
			} else if (request.status == 425) {						
					  alert("Fehler beim Eintragen von "+name.value+"\n"+request.responseText);													
				 } else {
			      // console.warn
				alert("newVar\n"+request.responseText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send();				

}


function newMusterVar(wo,name){
	if (name == null) return;
	if (name.trim() == "") return;
	var request = new XMLHttpRequest();
	//   consle.log("Start newMusterVar "+wo+" - "+name);
	if (wo == 4 || wo == 5)
	request.open("GET",call+"&set=NewVar&wo="+wo+"&name="+encodeURIComponent(name)); // ,false);
	else
	request.open("GET",call+"&set=NewMusterVar&wo="+wo+"&name="+encodeURIComponent(name)); // ,false);
	request.addEventListener('load', function(event) {
		   if (request.status == 200) {
			//   consle.log("NewMusterVar "+name+": "+request.responseText);
				loadNrF(wo,"NV"+wo);
			} else if (request.status == 425) {						
					  alert("Fehler beim Eintragen von "+name.value+"\n"+request.responseText);	
				loadNrF(1,null);
								
				 } else {
			      // console.warn
				alert("newMusterVar\n"+request.responseText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send();				
}

function moveUp(wo,pos){
	if (pos <= 0){
		alert("Aufwärts nicht möglich");
		return;
	}
	var show = false;
	if (wo == 100){
		var ziel = document.getElementById('jm'+pos);
		if (ziel.style.display.length > 1)
			if (ziel.style.display != 'none') show = true;
			//   consle.log(ziel.style.display + ' bei jm'+pos+' ergibt '+show);
	}

	var request = new XMLHttpRequest();
	request.open("GET",call+"&set=ActionPos&action=moveUp&wo="+wo+"&pos="+pos); // ,false);
	request.addEventListener('load', function(event) {
		   if (request.status == 200) {
				if (wo == 100 && show) loadNrF(wo,'show',pos-1);
				else loadNrF(wo);
			} else if (request.status == 425) {						
					  alert("Fehler bei aufwärts bewegen\n"+request.responseText);						
				 } else {
			      // console.warn
				alert("moveUp\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send();				

}
function moveDown(wo,pos){
	var request = new XMLHttpRequest();
	var show = false;
	if (wo == 100){
		var ziel = document.getElementById('jm'+pos);
		if (ziel.style.display.length > 1)
			if (ziel.style.display != 'none') show = true;
		//   consle.log(ziel.style.display + ' bei jm'+pos+' ergibt '+show);
						
	}
	
	request.open("GET",call+"&set=ActionPos&action=moveDown&wo="+wo+"&pos="+pos); // ,false);
	request.addEventListener('load', function(event) {
		   if (request.status == 200) {
				if (wo == 100 && show) loadNrF(wo,'show',pos+1);
				else loadNrF(wo);
			} else if (request.status == 425) {						
					  alert("Fehler bei abwärts bewegen\n"+request.responseText);						
				 } else {
			      // console.warn
				alert("moveDown\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send();				
}
function moveTo(vonWo,vonPos,nachWo,nachPos){
	var show = false;
	if (vonWo == 100){
		var ziel = document.getElementById('jm'+vonPos);
		if (ziel.style.display.length > 1)
			if (ziel.style.display != 'none') show = true;
		//   consle.log(ziel.style.display + ' bei jm'+vonPos+' ergibt '+show);
						
	}
	var request = new XMLHttpRequest();
	//   consle.log("Verschiebe mit moveTo&wo="+vonWo+"&pos="+vonPos+"&nachWo="+nachWo+"&nachPos="+nachPos);
	request.open("GET",call+"&set=ActionPos&action=moveTo&wo="+vonWo+"&pos="+vonPos+"&nachWo="+nachWo+"&nachPos="+nachPos); // ,false);
	request.addEventListener('load', function(event) {
		   if (request.status == 200) {
				if (nachWo == 100 && show) loadNrF(nachWo,'show',nachPos);
				else loadNrF(nachWo);				
				if (vonWo != nachWo) loadNrF(vonWo); 				
			} else if (request.status == 425) {						
					  alert("Fehler bei drag / drop\n"+request.responseText);						
				 } else {
			      // console.warn
				alert("moveTo\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send();				
}




function readSelectOptions(sort){
	console.log("Lese Select Options ");
	var request = new XMLHttpRequest();
	if (sort == null) sort = 'value'
	request.open("GET",call+"&set=SelectOptions&read=class_table&sort="+sort); // ,false);
	request.addEventListener('load', function(event) {
		   if (request.status == 200) {
				enterSelectOptions();
//				alert(request.responseText);					
			} else if (request.status == 425) {						
					alert("Fehler bei readSelectOptions\n"+request.responseText);													
		   } else {
			      // console.warn
				alert("editVar\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send();				
}

function renameStart(){
	var fo = document.getElementById("renameRow");
	fo.style.display='';
	
}

function renameClose(){
	var fo = document.getElementById("renameRow");
	//   consle.log(fo.style.display);
	fo.style.display='none';
}

function reportClass(){
	var fo = document.getElementById("saveForm");
	fo.action = "./reportClassDef.php"
	fo.target="QueryDok";
	fo.submit();
	return false;		
}

function translateClass(){
	var fo = document.getElementById("saveForm");
	fo.action = "./translateQuery.php"
	fo.target="QueryTranslate";
	fo.submit();
	return false;		
}

 function saveJoinMuster(name){
	var request = new XMLHttpRequest();
	request.open("GET",call+"&set=MusterVar&action=save&varName="+name); // ,false);
	request.addEventListener('load', function(event) {
		   if (request.status == 200) {
					  alert("Metadaten für "+name+" als Muster gespeichert.");													
			} else if (request.status == 425) {						
					  alert("Fehler bei editQuery\n"+request.responseText);													
		   } else {
			      // console.warn
				alert("editQuery\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send();				
 }


function saveMusterVar(){
	var request = new XMLHttpRequest();
	request.open("GET",call+"&set=MusterVar&action=save"); // ,false);
	request.addEventListener('load', function(event) {
		   if (request.status == 200) {			
				alert(request.responseText);	
			} else if (request.status == 425) {						
				 alert("Fehler beim Speichern des Musters\n"+request.responseText);	
				 } else {
			      // console.warn
				alert("newMusterVar\n"+request.responseText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send();				

}


/* umgestellt */
function setAttrib(attribute,value){
	var formData = new FormData();
	var request = new XMLHttpRequest();
	formData.append('id',requestID);
	formData.append('table',requestTable);
	formData.append('set','Attribute');
	formData.append('attribute',attribute);
	formData.append('value',value);

	request.open("POST","./editQuery.php");
	request.addEventListener('load', function(event) {
		   if (request.status == 200) {
			if (request.responseText != null && request.responseText.length > 10){
				alert (request.responseText);
			}
			if (attribute == 'histType' 
				|| attribute == 'historyOption'
				|| attribute == 'queryType'
				|| attribute == 'hatWerteAuswahl') loadNrF(0);
			} else if (request.status == 425) {						
					  alert("Fehler bei setAttrib\n"+request.responseText);													
		   } else {
			      // console.warn
				alert("setAttrib\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send(formData);				
}



function setJoinedQuery(vnr, attribute, value){	
	var formData = new FormData();
	var request = new XMLHttpRequest();
	formData.append('id',requestID);
	formData.append('table',requestTable);
	formData.append('set','JoinMetaEditor');
	formData.append('vnr',vnr);
	formData.append('attribute',attribute);
	formData.append('value',value);
	request.open("POST","./editQuery.php");
	
//	request.open("GET",call+"&set=JoinMetaEditor&vnr="+vnr+"&attribute="+attribute+"&value="+encodeURIComponent(value)); // ,false);
//	console.log("AUFRUF: "+call+"&set=JoinMetaEditor&vnr="+vnr+"&attribut="+attribute+"&value="+encodeURIComponent(value));
	request.addEventListener('load', function(event) {
		   if (request.status == 200) {
//					selectJoinWerte(pos);
				if (request.responseText != null && request.responseText.length > 10){
					alert (request.responseText);
	   		    }
				if (attribute == "type") loadNrF(100);
			} else if (request.status == 425) {						
					  alert("Fehler bei setJoinedQuery Werte\n"+request.responseText);													
		   } else {
			      // console.warn
				alert("editQuery\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send(formData);				
}

/* neu */
function setMetaAttrib(attribute,value){
	var formData = new FormData();
	var request = new XMLHttpRequest();
	formData.append('id',requestID);
	formData.append('table',requestTable);
	formData.append('set','MetaAttribute');
	formData.append('attribute',attribute);
	formData.append('value',value);
	
	request.open("POST","./editQuery.php");

	request.addEventListener('load', function(event) {
		   if (request.status == 200) {
				if (request.responseText != null && request.responseText.length > 10){
					alert (request.responseText);
				}else
				if (request.responseText > 0) loadNrF(request.responseText);
				if (attribute == 'type' && value > 20) loadNrF(0);
			} else if (request.status == 425) {						
					  alert("Fehler bei setAttrib\n"+request.responseText);													
		   } else {
			      // console.warn
				alert("setAttrib\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send(formData);				
}

function setSelectOptions(col){
	console.log("Set Select Options für "+col);
//	document.getElementById("Editor").style.display = "block";
//	document.getElementById("SelectWerte").style.display = "none";

	var selTable = document.getElementById("selectOptionsTable");
	var selTableBody = selTable.tBodies.item(0);
	var rows = selTableBody.rows;
	var i = 0;

	var formData = new FormData();
	var request = new XMLHttpRequest();
	formData.append('id',requestID);
	formData.append('table',requestTable);
	formData.append('set','SelectOptions');
	formData.append('size',''+rows.length);
	for (i = 0; i < rows.length; i++){
		var r = rows.item(i);
		var e = r.getElementsByTagName("input")
		var t = r.getElementsByTagName("textarea")
		var w = e.item(0).value;
		if (e.length > 1) var l = e.item(1).value;
		else var l = t.item(0).value;
		formData.append("V"+i,w);
		formData.append("L"+i,l);
	}

	request.open("POST","./editQuery.php");
	request.addEventListener('load', function(event) {
		   if (request.status == 200) {
				document.getElementById("Editor").style.display = "block";
				document.getElementById("SelectWerte").style.display = "none";
			} else if (request.status == 425) {						
					alert("Fehler bei setSelectOptions\n"+request.responseText);													
		   } else {
			      // console.warn
				alert("setSelectOptions\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send(formData);				
}

function setValueList(){
	console.log("Set Value List ");
//	document.getElementById("Editor").style.display = "block";
//	document.getElementById("SelectWerte").style.display = "none";

	var selTable = document.getElementById("selectOptionsTable");
	var selTableBody = selTable.tBodies.item(0);
	var rows = selTableBody.rows;
	var i = 0;

	var formData = new FormData();
	var request = new XMLHttpRequest();
	formData.append('id',requestID);
	formData.append('table',requestTable);
	formData.append('set','ValueList');
	formData.append('size',''+rows.length);
	for (i = 0; i < rows.length; i++){
		var r = rows.item(i);
		var e = r.getElementsByTagName("input")
		var w = e.item(0).value;
		var l = e.item(1).value;
		
		formData.append("V"+i,w);
		formData.append("L"+i,l);
	}

	request.open("POST","./editQuery.php");
	request.addEventListener('load', function(event) {
		   if (request.status == 200) {
				document.getElementById("SelectWerte").style.display = "none";
			} else if (request.status == 425) {						
					alert("Fehler bei setValueList\n"+request.responseText);													
		   } else {
			      // console.warn
				alert("setValueList\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send(formData);				
}



function selectDimensionVar(wo,pos){
	var request = new XMLHttpRequest();
	//   consle.log("Aufruf:"+call+"&set=ActionPos&action=selectDimVar&wo="+wo+"&pos="+pos);
	request.open("GET",call+"&set=ActionPos&action=selectDimVar&wo="+wo+"&pos="+pos); // ,false);
	request.addEventListener('load', function(event) {
		   if (request.status == 200) {
					  loadNrF(wo);						
			} else if (request.status == 425) {						
					  alert("Fehler beim Auswählen der Dimension / Variablen\n"+request.responseText);						
				 } else {
			      // console.warn
				alert("selectDimensionVar\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send();				
	return;		
	
}

function showDimensionVars(nr){
	var request = new XMLHttpRequest();
	request.open("GET",call+"&set=QueryActions&action=selectDimension&selectDimension="+nr); // ,false);
	request.addEventListener('load', function(event) {
		   if (request.status == 200) {
					  loadNrF(13);						
			} else if (request.status == 425) {						
					  alert("Fehler beim Auswählen der Dimension\n"+request.responseText);						
				 } else {
			      // console.warn
				alert("showDimensionVars\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send();				
	return;		
	
}

function showDimUse(){
	var fo = document.getElementById("saveForm");
	fo.action = "./showDimUse.php"
	fo.target="QueryTest";
	fo.submit();
	return false;		
}


function testReports(){
	var fo = document.getElementById("saveForm");
	fo.action = "./testReports.php"
	fo.target="QueryTest";
	fo.submit();
	return false;		
}

function testSql(){
	var fo = document.getElementById("saveForm");
	fo.action = "./showTestSQL.php"
	fo.target="SQL";
	fo.submit();
	return false;		
}

function testClass(){
	var request = new XMLHttpRequest();
	request.open("GET",call+"&get=Test"); // ,false);
	request.addEventListener('load', function(event) {
		   if (request.status == 200) {
					  alert(request.responseText);						
			} else if (request.status == 425) {						
					  alert("Fehler beim Testen der Datenquelle\n"+request.responseText);						
				 } else {
			      // console.warn
				alert("testClass\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send();				
	return false;		
}

function testClassE(){
	var request = new XMLHttpRequest();
	request.open("GET",call+"&get=TestElemente"); // ,false);
	request.addEventListener('load', function(event) {
		   if (request.status == 200) {
					  alert(request.responseText);						
			} else if (request.status == 425) {						
					  alert("Fehler beim Testen der Datenquelle\n"+request.responseText);						
				 } else {
			      // console.warn
				alert("testClass\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send();				
	return false;		
}


/* neu */
function umhaengen(nach){	
	var request = new XMLHttpRequest();
	request.open("GET",call+"&set=MetaAttribute&attribute=editSubject&value="+nach); // ,false);
	request.addEventListener('load', function(event) {
		   if (request.status == 200) {
			//   consle.log("umhängen Response "+request.responseText);
			loadNrF(request.responseText);
			loadNrF(nach);
			loadNrF(11);
			} else if (request.status == 425) {						
					  alert("Fehler bei setAttrib\n"+request.responseText);	
																	
		   } else {
			      // console.warn
				alert("setAttrib\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send();				
}


function newSelRow(feld){
	//   consle.log("newSelRow Select Options für "+feld.value);
	var selTable = document.getElementById("selectOptionsTable");
	var selTableBody = selTable.tBodies.item(0);
	var neueZeile = selTableBody.insertRow(-1);
	neueZeile.innerHTML=
		"<tr><td><input name=\"SOZW\" value=\""+feld.value+"\" size=\"15\" autocomplete=\"off\" /></td>"
		+"<td><input name=\"SOZL\" value=\"\" size=\"30\" autocomplete=\"off\" onchange=\"focusNewSel(this)\"/></td>"
		+"<td onclick=\"selOptUp(this)\" class=\"center\" name=\"auf\">"
		+"<img src=\"./icons/go-up.png\" alias=\"auf\" title=\"nach oben verschieben\" class=\"icon\" /></td>"
		+"<td onclick=\"selOptDown(this)\" class=\"center\" name=\"ab\">"
		+"<img src=\"./icons/go-down.png\" alias=\"ab\" title=\"nach unten verschieben\" class=\"icon\" /></td>"
		+"<td onclick=\"delSelRow(this)\" class=\"center\" name=\"del\">"
		+"<img src=\"./icons/delete.png\" alias=\"auf\" title=\"Zeile löschen\" class=\"icon\" /></td>";
	feld.value="";
	neueZeile.children.item(1).children.item(0).focus();
	selFocus = neueZeile.children.item(1).children.item(0)
}


function selOptDown(rowItem){
	var selTable = document.getElementById("selectOptionsTable");
	var selTableBody = selTable.tBodies.item(0);
	var rows = selTableBody.rows;
	var pos = findeRow(rows,rowItem,"ab");
	if (pos >= 0 && pos < rows.length-1){
		var row = rows.item(pos);
		selTableBody.deleteRow(pos);
		rows.item(pos).insertAdjacentElement('afterend', row);
	}	
}
function selOptUp(rowItem){
	var selTable = document.getElementById("selectOptionsTable");
	var selTableBody = selTable.tBodies.item(0);
	var rows = selTableBody.rows;
	var pos = findeRow(rows,rowItem,"auf");
	if (pos > 0 ){
		var row = rows.item(pos);
		selTableBody.deleteRow(pos);
		rows.item(pos-1).insertAdjacentElement('beforebegin', row);
	}	
	
}
function delSelRow(rowItem){
	var selTable = document.getElementById("selectOptionsTable");
	var selTableBody = selTable.tBodies.item(0);
	var rows = selTableBody.rows;
	var pos = findeRow(rows,rowItem,"ab");
	if (pos >= 0 ){
		selTableBody.deleteRow(pos);
	}	
	
}


function setFilterAnzeige(){
	console.log('setFilterAnzeige '+wo);
	var fo = document.getElementById("editorForm");
	var filterType = fo.filterType.value;
//	console.log("Filtertyp="+filterType);
//	console.log("WT1 hat="+document.getElementById("WT2").style.display);
    if (fo.selectFilterTable != null 
		&& fo.selectFilterTable.value != null
		&& fo.selectFilterTable.value.substring(0,1) == '#'){
			if (document.getElementById("WSel") != null) 
				document.getElementById("WSel").hidden = false;
			if (document.getElementById("WAnz") != null 
				&& document.getElementById("wo").value == 3) {
					document.getElementById("WAnz").hidden = true;
			if (document.getElementById("WT2") != null)
				document.getElementById("WT2").hidden = true;
			if (document.getElementById("WS") != null)
				document.getElementById("WS").hidden = true;
			if (document.getElementById("WS2") != null)
				document.getElementById("WS2").hidden = true;
			}
			if (document.getElementById("SO") != null)	
				document.getElementById("SO").hidden = true;	

			return;			
		} 
	if (document.getElementById("WSel") != null) document.getElementById("WSel").hidden = false;

	if (document.getElementById("wo").value == 3){
		if (filterType == 5 || filterType == 7 || filterType == 8){
			if (document.getElementById("WAnz") != null) document.getElementById("WAnz").hidden = false;
		}else{
			if (document.getElementById("WAnz") != null) document.getElementById("WAnz").hidden = true;
		}	
		//   consle.log("setFilterAnzeige: Filter hide select Anzeige")		
	} 
//	if (document.getElementById("WT2") == null) return;
	if (filterType > 0) {
		if (document.getElementById("WT2") != null)
			document.getElementById("WT2").hidden = false;	
		if (document.getElementById("FReq") != null)
			document.getElementById("FReq").hidden = false;	
	}
	else {
		if (document.getElementById("WT2") != null)
			document.getElementById("WT2").hidden = true;
		if (document.getElementById("FReq") != null)
			document.getElementById("FReq").hidden = true;	
	}
	if (filterType == 1 || filterType == 4 ){
		document.getElementById("WT").hidden = false;
		if (fo.selectFilterTable.value == ""){
		if (document.getElementById("WT2") != null)
			document.getElementById("WT2").hidden = true;
		if (document.getElementById("WS") != null)
			document.getElementById("WS").hidden = true;
		if (document.getElementById("WS2") != null)
			document.getElementById("WS2").hidden = true;
		if (document.getElementById("SO") != null)
			document.getElementById("SO").hidden = false;
			
		}else{
		if (document.getElementById("WT2") != null)
			document.getElementById("WT2").hidden = false;
		if (document.getElementById("WS") != null)
			document.getElementById("WS").hidden = false;
		if (document.getElementById("WS2") != null)
			document.getElementById("WS2").hidden = false;
		if (document.getElementById("SO") != null)
			document.getElementById("SO").hidden = true;
		}
	    if (document.getElementById("WAnz") != null) document.getElementById("WAnz").hidden = false;
	}else if (filterType == 8 ){
	    if (document.getElementById("WAnz") != null) document.getElementById("WAnz").hidden = false;
		if (document.getElementById("WT") != null)
			document.getElementById("WT").hidden = false;
		if (document.getElementById("WT2") != null)
			document.getElementById("WT2").hidden = true;
		if (document.getElementById("WS") != null)
			document.getElementById("WS").hidden = true;
		if (document.getElementById("WS2") != null)
			document.getElementById("WS2").hidden = true;
		if (document.getElementById("SO") != null)
			document.getElementById("SO").hidden = true;
	}else if (filterType == 10 ){  // Liste
		if (document.getElementById("WT") != null)
			document.getElementById("WT").hidden = false;
		if (document.getElementById("FReq") != null)
			document.getElementById("FReq").hidden = true;
		if (document.getElementById("SO") != null)
			document.getElementById("SO").hidden = true;
		if (fo.selectFilterTable.value == ""){
			if (document.getElementById("WT2") != null)
					document.getElementById("WT2").hidden = true;
			if (document.getElementById("WS") != null)
					document.getElementById("WS").hidden = true;
			if (document.getElementById("WS2") != null)
					document.getElementById("WS2").hidden = true;			
		}else{
			if (document.getElementById("WT2") != null)
				document.getElementById("WT2").hidden = false;
			if (document.getElementById("WS") != null)
				document.getElementById("WS").hidden = false;
			if (document.getElementById("WS2") != null)
				document.getElementById("WS2").hidden = false;
		}
	    if (document.getElementById("WAnz") != null) document.getElementById("WAnz").hidden = false;
	}else if (filterType == 23 ){  // Gelöscht am
		if (document.getElementById("SO") != null)
			document.getElementById("SO").hidden = false;
		if (document.getElementById("FReq") != null)
			document.getElementById("FReq").hidden = false;
		if (document.getElementById("WT2") != null)
			document.getElementById("WT2").hidden = true;
	}else{
		if (document.getElementById("WT") != null)
			document.getElementById("WT").hidden = true;
		if (document.getElementById("WT2") != null)
			document.getElementById("WT2").hidden = true;
		if (document.getElementById("WS") != null)
			document.getElementById("WS").hidden = true;
		if (document.getElementById("WS2") != null)
			document.getElementById("WS2").hidden = true;
		
		if (document.getElementById("SO") != null){
			if (filterType == 7 )
				document.getElementById("SO").hidden = false;
			else 
				document.getElementById("SO").hidden = true;
		}
	}
	
	if (document.getElementById("wo").value != 3) {
	    if (document.getElementById("WAnz") != null) document.getElementById("WAnz").hidden = false;
//   consle.log("setFilterAnzeige: Kein Reiner Filter")		
	}
   console.log("setFilterAnzeige: WT = "+document.getElementById("WT").value+' -> '
				+(document.getElementById("WT").value > ''));		
	if (document.getElementById("WT").value > '') {
	    if (document.getElementById("WAnz") != null) document.getElementById("WAnz").hidden = false;
		consle.log("setFilterAnzeige: show WAnz");
	}

}


function setPosAttribute(wo,pos,was,wert){
	if (wo != 'DefaultFilter'){
		alert("Ungültiger Aufruf von setActionPos\nmit ".wo);
		return;		
	}
	var request = new XMLHttpRequest();
	request.open("GET",call+"&set=ActionPos&action=defaultFilter&wo=6&pos="+pos+"&was="+
		was+"&wert="+encodeURIComponent(wert)); // ,false);
	request.addEventListener('load', function(event) {
		   if (request.status == 200) {
				loadNrF(6);
			} else if (request.status == 425) {						
					  alert("Fehler bei set Default Filter\n"+request.responseText);						
				 } else {
			      // console.warn
				alert("defaultFilter\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send();				

}

function updateDimHist(nr){
	var request = new XMLHttpRequest();
	request.open("GET",call+"&set=QueryActions&action=updateDimHist&dimNr="+nr);
	request.addEventListener('load', function(event) {
		   if (request.status == 200) {
				loadNrF(13);
			} else if (request.status == 425) {						
					  alert("Fehler bei set Default Filter\n"+request.responseText);						
				 } else {
			      // console.warn
				alert("defaultFilter\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send();				

	
}


function hideFoot(){
	document.getElementById("footLong").style.display = "none";
	document.getElementById("footShort").style.display = "inline";
}
function showFoot(){
	document.getElementById("footLong").style.display = "grid";
	document.getElementById("footShort").style.display = "none";
}

function saveClass(closeWindow){
	var request = new XMLHttpRequest();
	request.open("GET",call+"&set=QueryActions&action=saveClass"); // ,false);
	request.addEventListener('load', function(event) {
		   if (request.status == 200) {
					  alert(request.responseText);
					if (closeWindow) window.close();						
			} else if (request.status == 425) {						
					  alert("Fehler beim Speichern des Objekts\n"+request.responseText);						
				 } else {
			      // console.warn
				alert("saveClass\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send();				
	return false;		
}


function initClass(){
	var request = new XMLHttpRequest();
	request.open("GET",call+"&set=InitClass"); // ,false);
	request.addEventListener('load', function(event) {
		   if (request.status == 200) {
				loadNrF (1,null);
				loadNrF (2,null);
			} else if (request.status == 425) {						
					  alert("Fehler beim Initialisieren der Datenquelle\n"+request.responseText);						
				 } else {
			      // console.warn
				alert("initClass\n"+request.statusText+" "+ request.status+"\n"+request.responseText);
			   }
			});
	request.send();				

}

function befehlAusfuehren(){
	var befehl = document.getElementById('befehl').value;
	if (befehl == "initClass"){
		initClass();
	}else
	if (befehl == "deleteClass"){
		deleteClass();
	}else
	if (befehl == "reportClass"){
		reportClass();
	}else
	if (befehl == "testClass"){
		testClass();
	}else
	if (befehl == "testClassE"){
		testClassE();
	}else
	if (befehl == "testSql"){
		testSql();
	}else
	if (befehl == "testReports"){
		testReports();
	}else
	if (befehl == "showDimUse"){
		showDimUse();
	}else
	if (befehl == "exportClass"){
		exportClass();
	}else
	if (befehl == "translateClass"){
		translateClass();
	}

}

/**
 * Drag and drop
 */

var oldColor = null;
var vonWo = null;
var vonPos = null;
function dragEnter(o){
}

function dragLeave(o){
	if (o.hasAttribute('backup_bColor')) o.style.backgroundColor = o.getAttribute('backup_bColor');  
}

function dragStart(event,wo,pos){
	vonWo = wo;
	vonPos = pos;
	event.dataTransfer.dropEffect = 'move';
 	event.effectAllowed = "move";
}

function drop(event,wo,pos,o){
	o = event.target;	
	if (o.hasAttribute('backup_bColor')) o.style.backgroundColor = o.getAttribute('backup_bColor');  
	moveTo(vonWo,vonPos,wo,pos);			
}

function dragOver(event,wo,o){
	if (vonWo == wo) {
		if (! o.hasAttribute('backup_bColor')) {
			if (o.style.backgroundColor != null) o.setAttribute('backup_bColor', o.style.backgroundColor);
			else o.setAttribute('backup_bColor', '');
		}
		o.style.backgroundColor = '#aaff88';
		event.preventDefault();	
	}	
}

