/**
 * Projekt: WS-Reporter
 *          JavaScript-Funktionen für Übersetzung der Anwendung
 *
 * Autor:    Wilfried Schollenberger
 *           WS Unternehmensberatung und Controlling-Systeme GmbH
 * Kontakt:  wisch@ws-unternehmensberatung.de
 * Lizenz:   GPL 3.0
 *
 * Stand:    21.6.2022
 *
 * Parameter:
 *      action: 
 *      tLanguage: Sprache, in die übersetzt wird
 *      type: qLanguageType: Typ der Übersetzung
 *      text: Text, der übersetzt wird
 *      translation: Übersetzung
 */

/* globale Variablen */
var language = 'de';

function enter(inputObject,language,idDE){	

	var formData = new FormData();
	formData.append('action','enter');
	formData.append('tLanguage',language);
	formData.append('type',0);
	formData.append('text',document.getElementById(idDE).value);
	formData.append('translation',inputObject.value);
	console.log(formData);
	var request = new XMLHttpRequest();
	request.open("POST","./wsrTranslate.php");
	request.addEventListener('load', function(event) {
			   if (request.status == 200) {
					console.log(request.responseText);				
				} else if (request.status == 425) {						
				  	alert("Fehler bei enter Translation\n"+request.responseText);
				} else if (request.status == 400) {						
				  	alert("Fehler:\n"+request.responseText);
			   } else {
					alert("enter\n"+request.statusText+" "+ request.status
				+"\n"+request.responseText);
			   }
			});
	request.send(formData);		
	console.log('S>'+inputObject.value+'<');
				
}

function showTranslationById(id){
	var t = document.getElementById(id);
	if (t != null && t.lang != null) showTranslation(t.value,t.lang);
	else console.log('FEHLER: ID='+id+' nicht gefunden oder ohne lang-Attribut');
}

function showTranslation(text,lang){
	var formData = new FormData();
	formData.append('text',text);
	formData.append('language',lang);
	console.log(formData);
	var request = new XMLHttpRequest();
	request.open("POST","./translateWSRSearch.php");
	request.addEventListener('load', function(event) {
			   if (request.status == 200) {
				alert(
					request.responseText);
					}else{
				alert("FEHLER:\n"+
					request.responseText);
						
					}
					});
	request.send(formData);								
	
}

function deleteTranslationById(id){
	var t = document.getElementById(id);
	if (t != null && t.lang != null) {
	if (window.confirm("Soll der Eintrag\n"+t.value+"\nwirklich gelöscht werden?")){
		var formData = new FormData();
		
		formData.append('action','delete');
		formData.append('type',0);
		formData.append('text',t.value);
		console.log(formData);
		var request = new XMLHttpRequest();
		request.open("POST","./wsrTranslate.php");
			request.addEventListener('load', function(event) {
			   if (request.status == 200) {
				    var p = t.parentElement;
					while (p.tagName != 'TR') p = p.parentElement;
						p.remove();
					}else{
						alert("FEHLER:\n"+
						request.responseText);
					}
					return false;
				}
			);
			request.send(formData);								
		}
	}
	else console.log('FEHLER: ID='+id+' nicht gefunden oder ohne lang-Attribut');
}



