<?php
/**
 * Projekt: WS-Reporter
 *          Globale Tests
 *          * aktuell nur für Filter
 *
 * Autor:    Wilfried Schollenberger
 *           WS Unternehmensberatung und Controlling-Systeme GmbH
 * Kontakt:  wisch@ws-unternehmensberatung.de
 * Lizenz:   GPL 3.0
 *
 * Stand:    27.12.2021
 *
 */
include 'includes/defender.inc';
global $query, $meldungen;
require_once './includes/funktionen.inc';
require_once './includes/classes.inc';
if (false){
    $query = new Query("tab");
    $rq = new Query("tab");
    $jquery = new Query("tab");
    $aq = new AddedQuery("tab");
    $mr = new MetaRecord();
    $mr2 = new MetaRecord();
    $mrf = new MetaRecord();
    $jt = new JoinedTable(null);
    $fSpec = new RepFilter("fi");
}

global $query, $wsReportVersion;
$meldungen = "";
$border ="";
$query = null;
if (session_status() == PHP_SESSION_NONE)  session_start();
anmeldungPruefen();

session_abort();
leseRechteVerlangen();

$sql = new SqlAbfrage('WSR');
$sql->sql = <<<EOS
 select  distinct binary(q.column_name) as column_name, b.AnzColumn, q.qFilterTyp, a.Anzahl, q.table_name, q.column_label, q.column_desc,
     q.qColType, q.qSelectVar, q.qDisplayVar, 
      ifnull(q.qSelectFilterTable,'&nbsp;') as qSelectFilterTable, c.AnzFilterTab
     from queryColumnMetadata q, 
     (select distinct column_name, qFilterTyp, count(*) as Anzahl from queryColumnMetadata
      group by binary(column_name), qFilterTyp) a,
     (select distinct column_name, count(*) as AnzColumn from queryColumnMetadata
      group by binary(column_name)) b,
     (select distinct column_name, qFilterTyp, qSelectFilterTable, count(*) as AnzFilterTab from queryColumnMetadata
      group by binary(column_name), qFilterTyp, binary(qSelectFilterTable) ) c
      
     where q.column_name in 
     ( select q2.column_name
          from (
              select q1.column_name, count(*) as Anz 
                from (select distinct column_name, qFilterTyp, qSelectFilterTable
                        from queryColumnMetadata where qFilterTyp > 0) q1
                 group by binary(q1.column_name)
               having count(*) > 1
               ) q2
     )
     and binary q.column_name = b.column_name
     and q.qFilterTyp = a.qFilterTyp and binary q.column_name = a.column_name
     and q.qFilterTyp = c.qFilterTyp and binary q.column_name = c.column_name 
          and binary  ifnull(q.qSelectFilterTable,'&nbsp;') =  ifnull(c.qSelectFilterTable,'&nbsp;')
  order by binary(q.column_name), a.Anzahl desc, q.qFilterTyp, c.AnzFilterTab, binary(q.qSelectFilterTable), q.table_name
 EOS;        
$stmt = $sql->execute();

?>
<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<title>WS-Reporter: Globale Prüfungen der Datenquellen</title>
<meta name="GENERATOR" content="WS-PHP: testGlobal.php">
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<link rel="stylesheet" href="./jscss/standard2.css">
<script type="text/javascript" src="./jscss/tableHeader.js">
	</script>

</head> 
<?php 
if ($_SERVER["HTTP_HOST"] == "localhost:8898") echo '<body class="entwicklung">';
else echo '<body>';
?>
<h1>WS-Reporter: Globale Prüfungen der Datenquellen</h1>
<center>
<div class="inlineBox">
<h3>Gleichnamige Filter mit verschiedenen Typen</h3>
<table id="Tabelle">
<thead>
<tr><th>Name</th><th>Typ</th><th>Filter-Table</th><th>Datenquelle</th><th>Label</th>
<th>Select</th><th>Display</th></tr>
</thead>
<tbody>
<?php
$column = '';
while($z = $stmt->fetchObject()){
    if ($z->qSelectFilterTable == null) $z->qSelectFilterTable = '';
    if ($z->column_name != $column){
        $column = $z->column_name;
        $filterTyp = $z->qFilterTyp;
        $filterTable = $z->qSelectFilterTable;
        ?>
<tr><th class="top left" rowspan="<?=$z->AnzColumn ?>"><?=$z->column_name ?></th>
    <th class="top left" rowspan="<?=$z->Anzahl ?>"><?=MetaRecord::klartextFilter[$z->qFilterTyp] ?></th>
    <td class="top left" rowspan="<?=$z->AnzFilterTab ?>"><?=$z->qSelectFilterTable ?></td> 
<?php
    }elseif ($filterTyp != $z->qFilterTyp){
        $filterTyp = $z->qFilterTyp;
        $filterTable = $z->qSelectFilterTable;
        ?>
<tr><th class="top left" rowspan="<?=$z->Anzahl ?>"><?=MetaRecord::klartextFilter[$z->qFilterTyp] ?></th> 
    <td class="top left" rowspan="<?=$z->AnzFilterTab ?>"><?=$z->qSelectFilterTable ?></td> 
<?php
    }elseif ($filterTable != $z->qSelectFilterTable){
        $filterTable = $z->qSelectFilterTable;
        ?>
<tr><td class="top left" rowspan="<?=$z->AnzFilterTab ?>"><?=$z->qSelectFilterTable ?></td> 
<?php
    } else echo '<tr>'        
?>
 <td><a href="./editQuery.php?table=<?=$z->table_name ?>" target="QueryEditor"><?=$z->table_name ?></a></td>
 <td <?=makeTitle($z->column_desc) ?>><?=$z->column_label ?></td>
 <td><?=$z->qSelectVar ?></td><td><?=$z->qDisplayVar ?></td>
 </tr>

<?php
//  <td>&gt;<?=$z->qSelectFilterTable ? >&lt:</td>

?>
 

<?php
}
?>
</tbody>

</table>

<?php 
 // ENDE filterTest
?>
</div></center>
<footer class="leiste">
<div class="Fleft">WS Reporting Version <?=$wsReportVersion?></div>
<div class="Fright right">&copy; WS Unternehmensberatung</div>
</footer>
</body>
</html>
</body>
</html>
