<?php
/**
 * Projekt: WS-Reporter
 *          Test, ob alle Reports zu einer Datenquelle lauffähig sind
 *
 * Autor:    Wilfried Schollenberger
 *           WS Unternehmensberatung und Controlling-Systeme GmbH
 * Kontakt:  wisch@ws-unternehmensberatung.de
 * Lizenz:   GPL 3.0
 *
 * Stand:    7.10.2021
 *
 */
include 'includes/defender.inc';
// Ausgabe der Report-Definition
global $query, $meldungen;
require_once './includes/funktionen.inc';
require_once './includes/classes.inc';
if (false){
    $query = new Query("tab");
    $rq = new Query("tab");
    $jquery = new Query("tab");
    $aq = new AddedQuery("tab");
    $mr = new MetaRecord();
    $mr2 = new MetaRecord();
    $mrf = new MetaRecord();
    $jt = new JoinedTable(null);
    $fSpec = new RepFilter("fi");
}

function klartext($ft){
    if ($ft == 0) return ' -&nbsp;kein&nbsp;Filter';
    return MetaRecord::klartextFilter[$ft];
}

global $query, $wsReportVersion;
$meldungen = "";
$border ="";
$query = null;
if (session_status() == PHP_SESSION_NONE)  session_start();
anmeldungPruefen();

if (array_key_exists('WSReportQuery', $_SESSION)){
    $query = $_SESSION['WSReportQuery'];
}
session_write_close();
leseRechteVerlangen();

if (array_key_exists('table', $_REQUEST)){
    if ($query == null || $query->class_table != $_REQUEST['table']){
        require_once './includes/loadClassDef.inc';
        $query = new Query($_REQUEST['table']);
        loadClassDef($query);
    }
}
if ($query == null){
    echo "FEHLER:<br>Die Defintion der Datenquelle ".$_REQUEST['table']." konnte nicht geladen werden.";
    echo '<br><pre>';var_dump($query);echo '</pre>';
    die();
}
$meldungen ='';


?>
<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<?php 
if (!array_key_exists('filterTest', $_REQUEST)){
?>
<title>WS-Reporter: Prüfung <?=$query->class_table ?> für Reports und Filter</title>
<?php
}else{
?>
<title>WS-Reporter: Filter-Prüfung für <?=$query->class_table ?></title>
<?php
}
?>
<meta name="GENERATOR" content="WS-PHP: testReports.php">
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<link rel="stylesheet" href="./jscss/standard2.css">
<link rel="stylesheet" href="<?=$query->reportCSS ?>" >
</head> 
<?php 
if ($_SERVER["HTTP_HOST"] == "localhost:8898") echo '<body class="entwicklung">';
else echo '<body>';

if (!array_key_exists('filterTest', $_REQUEST)){

$sql = 'select s.typ, s.name, s.reportID, t.reportTitle_'.substr($_SESSION['Sprache'], 0,2).' as reportTitle from (';
$sql .= <<<EOS
select 'Zeile/Spalte' as typ, r.column_name as name, r.reportID from reportRows r
  where r.reportID in (select reportID from reportAttributes 
                       where table_name = :table1)
    and r.column_name not in (select column_name from queryColumnMetadata
                             where table_name = :table2 and SpaltenTyp = 1)
union
select 'Zeile/Spalte' as typ, c.column_name as name, c.reportID from reportColumns c
  where c.reportID in (select reportID from reportAttributes 
                       where table_name = :table3)
    and c.column_name not in (select column_name from queryColumnMetadata
                             where table_name = :table4 and SpaltenTyp = 1)
union
select 'Wert' as typ, v.column_name as name, v.reportID from reportValues v
  where v.reportID in (select reportID from reportAttributes 
                       where table_name = :table5)
    and v.wfFunction = 0 
    and v.column_name not in (select column_name from queryColumnMetadata
                             where table_name = :table6 and SpaltenTyp = 2)
union
select 'Wert' as typ, vc.val_name as name, vc.reportID from reportColumns vc
  where vc.reportID in (select reportID from reportAttributes 
                       where table_name = :table7)
    and vc.val_name not in (select column_name from queryColumnMetadata
                             where table_name = :table8 and SpaltenTyp = 2)
union
select 'Filter' as typ, f.column_name as name, f.reportID from reportFilters f
  where f.reportID in (select reportID from reportAttributes 
                       where table_name = :table9)
    and f.column_name not in (select column_name from queryColumnMetadata
                             where table_name = :table10 and qFilterTyp > 0)
union                             
select 'Filter' as typ, fc.filter as name, fc.reportID from reportColumns fc
  where fc.reportID in (select reportID from reportAttributes 
                       where table_name = :table11)
    and fc.filter not in (select column_name from queryColumnMetadata
                             where table_name = :table12 and qFilterTyp > 0)
union
select 'Wert' as typ, v.wfValue as name, v.reportID from reportValues v
  where v.reportID in (select reportID from reportAttributes
                       where table_name = :table13)
    and v.wfFunction > 0 
    and v.wfValue not in (select column_name from queryColumnMetadata
                             where table_name = :table14 and SpaltenTyp = 2)
) s                             
left join reportTitle t on t.reportID = s.reportID
where substring(s.name,2,1) not in (':','=')
and s.name not like "#webLink%"
and s.name not like "#window%"
and s.name not like "WSR_WINDOWVALUE%"
order by typ, name, reportTitle
EOS;
$par = array();
for ($i=1; $i <= 14; $i++) {
    $par['table'.$i] = $query->class_table;
}

?>
<h1>Test der Reports zu <?=quoteForHTML($query->outputTitlePrefix )?></h1>

<div class="kommentar">
<?php 
$stmt = $dbh->prepare($sql);
if ($stmt === false){
    $erg = false;
    $stmt = $dbh;
}else{
    $erg = $stmt->execute($par);
}
$esFehlen = false;
$letzterReport = null;
$name = null;
if ($erg !== false){
    while ($z = $stmt->fetchObject()){
        if (! $esFehlen){
            $esFehlen = true;
            $name = $z->name;
?>            
<h3><?=WSRTranslate::translate('In den Report-Definitionen wurden Variablen gefunden'
      .',<br>die mit dieser Quelle nicht mehr geliefert werden')?>.</h3>
<table <?=$border ?> class="aLeft">
<thead><tr><th><?=WSRTranslate::translate('Verwendung')?></th><th><?=WSRTranslate::translate('Name')?></th>
<th><?=WSRTranslate::translate('Reports')?></th></tr></thead>
<tbody>
<tr><th><?=$z->typ ?></th><th class="left"><?=$z->name ?></th><td><?=$z->reportTitle ?>
<?php 
        }else  if ($name != $z->name){
            $name = $z->name;
?>
</td></tr><tr><th><?=$z->typ ?></th><th class="left"><?=$z->name ?></th><td><?=$z->reportTitle ?>
<?php 
        }else{
?>
<br><?=$z->reportTitle ?>
<?php 
        }
    }
    if ($esFehlen){
?>
</td></tr> 
</tbody> 
</table>
<?php 
    }else{
            ?>
<h3>Keine Fehler gefunden</h3>
	
<?php
    }
}else{
?>    
<h3>Fehler in der Abfrage</h3>

<?php
echo '<p>'.$stmt->errorInfo()[2].'</p>';
}
?>

</div>
<h1>Filter-Prüfung</h1>
<div class="kommentar">
<table>
<?php 
$frc = 0;
foreach ($query->metaData as $mr){
    if (false) $mr = new MetaRecord();
    if ($mr->filterType > 0){

$sql = new SqlAbfrage('WSR');
$sql->sql = 'select  distinct qFilterTyp, qSelectFilterTable, count(*) as Anzahl from queryColumnMetadata'; 
$sql->addSel('column_name = ', $mr->getName());
$sql->addSel('table_name != ', $query->class_table);
$sql->addSel('qFilterTyp != ',$mr->filterType);
if ($mr->selectFilterTable != null) $sql->addSel('qSelectFilterTable != ',$mr->selectFilterTable);
$sql->sql .= ' group by qFilterTyp, qSelectFilterTable';
$sql->sql .= ' order by qFilterTyp, qSelectFilterTable';
$stmt = $sql->execute();
$rc = 0;
while ($z=$stmt->fetchObject()){
    if ($rc == 0){
        $rc = 1;
        $frc++;
        ?>
<tr class="gray"><th class="left"><?=$mr->getName().' ('.klartext($mr->filterType).')' ?></th>
<td colspan = "3" class="nowrap">ist in anderen Datenquellen abweichend definiert:</td></tr>          
<?php 
    }
    ?>
<tr><th>&nbsp;</th><td class="center"><?=$z->Anzahl ?></td><td><?=klartext($z->qFilterTyp) ?></td><td><?=$z->qSelectFilterTable ?></td>    
<?php 
    
}
if ($rc){
    $sql = new SqlAbfrage('WSR');
    $sql->sql = 'select  count(*) as Anzahl from queryColumnMetadata';
    $sql->addSel('column_name = ', $mr->getName());
    $sql->addSel('table_name != ', $query->class_table);
    $sql->addSel('qFilterTyp = ',$mr->filterType);
    if ($mr->selectFilterTable != null) $sql->addSel('qSelectFilterTable = ',$mr->selectFilterTable);
    $stmt = $sql->execute();
    $rc = 0;
    if ($z=$stmt->fetchObject()){        
    ?>
<tr><th>&nbsp;</th><td colspan="3"><?= $z->Anzahl ?> gleiche Definitionen</td></tr>    
<?php 
    }
}

    }
}
?>
</table>
<?php 
if ($frc > 0 && !array_key_exists('filterTest', $_REQUEST)){
    ?>
<div class="center"><form action="<?=$_SERVER['PHP_SELF']?>" method="POST" target="NEU">
<input type="submit" name="filterTest" value="Abweichungen zeigen" />
<?php
foreach ($_POST as $n => $p){    
?>
<input type="hidden" name="<?=$n?>" value="<?=$p?>" />
<?php
}
?>

</form></div>
<?php 
       
}
}else{ // filterTest
?>
<h1>Filter-Prüfung für <?=quoteForHTML($query->class_table.': '.$query->outputTitlePrefix  )?></h1>
<div class="kommentar">
<table>
<?php
$frc = 0;
foreach ($query->metaData as $mr){
    if (false) $mr = new MetaRecord();
    if ($mr->filterType > 0){
        
        $sql = new SqlAbfrage('WSR');
        $sql->sql = 'select  table_name,column_name, qSelectVar, qDisplayVar, qFilterTyp, qSelectFilterTable  from queryColumnMetadata';
        $sql->addSel('column_name = ', $mr->getName());
        $sql->addSel('table_name != ', $query->class_table);
        $sql->addSel('qFilterTyp != ',$mr->filterType);
        if ($mr->selectFilterTable != null) $sql->addSel('qSelectFilterTable != ',$mr->selectFilterTable);
        $sql->sql .= ' order by qFilterTyp, qSelectFilterTable, table_name';
        $stmt = $sql->execute();
        $rc = 0;
        $za = $stmt->fetchAll(PDO::FETCH_CLASS);
        if ($mr->getName() == 'BetreuungsartSL'){
//            error_log(print_r($za,true));
//            error_log ("SQL:".$sql->sql);
        }
        if (count($za) > 0){                    
            ?>
     <tr class="gray"><th class="left"><?=$mr->getName()?></th><th>&nbsp;</th><th class="left"><?=klartext($mr->filterType) ?></th>
            <td><?=$mr->selectVar?></td><td><?=$mr->displayVar?></td><td><?=$mr->selectFilterTable?></td></tr>
   <?php          
            
            $sql = new SqlAbfrage('WSR');
            $sql->sql = 'select  table_name,column_name, qSelectVar, qDisplayVar, qFilterTyp, qSelectFilterTable from queryColumnMetadata';
            $sql->addSel('column_name = ', $mr->getName());
            $sql->addSel('table_name != ', $query->class_table);
            $sql->addSel('qFilterTyp = ',$mr->filterType);
            if ($mr->selectFilterTable != null) $sql->addSel('qSelectFilterTable = ',$mr->selectFilterTable);
            $sql->sql .= ' order by table_name';
            $stmt2 = $sql->execute();
            $zg = $stmt2->fetchAll(PDO::FETCH_CLASS);
            if (count($zg)> 0){
                ?>
     <tr><td class="left top" rowspan="<?=count($zg)?>">gleicher Typ</td>
     <th class="left" colspan="2"><?=$zg[0]->table_name?></th>
            <td><?=$zg[0]->qSelectVar?></td><td><?=$zg[0]->qDisplayVar?></td><td><?=$zg[0]->qSelectFilterTable?></td></tr>
   <?php          
   for ($i=1; $i < count($zg); $i++ ){
       ?>
<tr><th class="left" colspan="2"><?=$zg[$i]->table_name?></th>
            <td><?=$zg[$i]->qSelectVar?></td><td><?=$zg[$i]->qDisplayVar?></td><td><?=$zg[$i]->qSelectFilterTable?></td></tr>    
<?php 
       
   }
            }
            ?>
     <tr style="background-color:#ffeedd"><td class="left top" rowspan="<?=count($za)?>">abweichend</td>
     <th class="left"><?=$za[0]->table_name?></th><td class="left"><?=klartext($za[0]->qFilterTyp) ?></td>
            <td><?=$za[0]->qSelectVar?></td><td><?=$za[0]->qDisplayVar?></td><td><?=$za[0]->qSelectFilterTable?></td></tr>
   <?php         
   for ($i=1; $i < count($za); $i++ ){
       ?>
<tr style="background-color:#ffeedd"><th class="left"> <?=$za[$i]->table_name?></th><td class="left"><?=klartext($za[$i]->qFilterTyp) ?></td>
            <td><?=$za[$i]->qSelectVar?></td><td><?=$za[$i]->qDisplayVar?></td><td><?=$za[$i]->qSelectFilterTable?></td></tr>    
<?php 
       
   }
            }
            
            
                ?>
<?php 
    }
}
 
?>
</table>

<?php 
} // ENDE filterTest
?>
</div>
<footer class="leiste">
<div class="Fleft">WS Reporting Version <?=$wsReportVersion?></div>
<div class="Fright right">&copy; WS Unternehmensberatung</div>
</footer>
</body>
</html>
</body>
</html>
