<?php 
/**
 * Projekt: WS-Reporter
 *          Suche nach Verwendung einer Übersetzung
 *
 * Autor:    Wilfried Schollenberger
 *           WS Unternehmensberatung und Controlling-Systeme GmbH
 * Kontakt:  wisch@ws-unternehmensberatung.de
 * Lizenz:   GPL 3.0
 *
 * Stand:    8.5.2022
 * 
 *
 */

/* ??
if (array_key_exists('class_table', $_REQUEST)){
    $sql = new SqlAbfrage('WSR');
    $sql->sql = 
}
*/
require 'includes/defender.inc';

require_once './includes/funktionen.inc';
require_once './includes/classes.inc';
require_once './includes/qTranslate.inc';
require_once './includes/translateFunktionen.inc';

if (session_status() == PHP_SESSION_NONE)  session_start();
anmeldungPruefen();
uebersetzerRechteVerlangen();
/*
if (array_key_exists('table', $_REQUEST)){
    $table = $_REQUEST['table'];
}else{
    $table = $query->class_table;
}
if (!isValid($table)){
    http_response_code(400);
    echo 'Name der Datenquelle fehlt (Parameter: table)';
    die();    
}
*/
$tSearch = '';
if (array_key_exists('text',$_REQUEST)) $tSearch = $_REQUEST['text'];
if (!isValid($tSearch)){
    http_response_code(400);
    echo 'Text für Suche fehlt (Parameter: text)';
    die();
}
$tSearch = wsrDecode($tSearch);

$lang = substr($_REQUEST['language'], 0,2);


/* Liste der zu übersetzenden Texte */
$sql = new SqlAbfrage('WSR');

$sql->sql = "select qLanguageType, de, en, fr from queryTranslations";
$sql->addSel($lang.' = ', $tSearch);

error_log('TSearch '.$lang.' -> '.$tSearch);

$stmt = $sql->execute();
if ($stmt === false){
    var_dump($sql);
    var_dump($dbh->errorInfo());
    die();
}
$z = $stmt->fetchObject();
if ($z === false){
    http_response_code(201);
    echo "Der Text:\n".$tSearch."\nwurde in der Sprache ".$lang." nicht gefunden.";
    return;
}
echo 'Typ: '.$z->qLanguageType
    ."<br>\nDeutsch: ".$z->de
    ."<br>\nEnglisch: ".$z->en
    ."<br>\nFranzösisch: ".$z->fr
;
$c = 0;
if (isValid($z->de)){
    $stmt = sqlSearch($z->de);
    $c += showUsage($stmt, 'Verwendung in Deutsch', 'VerwTable', 2);    
}
if (isValid($z->en)){
    $stmt = sqlSearch($z->en);
    if ($c > 0)  $c += showUsage($stmt, 'Verwendung in Englisch', 'VerwTable', 3);
    else  $c += showUsage($stmt, 'Verwendung in Englisch', 'VerwTable', 2);
}
if (isValid($z->fr)){
    $stmt = sqlSearch($z->fr);
    if ($c > 0)  $c += showUsage($stmt, 'Verwendung in Französisch', 'VerwTable', 3);
    else  $c += showUsage($stmt, 'Verwendung in Französisch', 'VerwTable', 2);
}
if ($c > 0) echo '</tbody></table>';
else {
?>
<div id='todel' class='hidden'><pre><?=$z->de ?></pre></div>
<br><button onclick='deleteTranslationTodel()'><?=WSRTranslate::translate('Eintrag löschen')?></button> 
<?php 
}
?>    
